var myService=angular.module('starter.services',['ngCordova'])

//提供键值对形式的 数据传输模式
.factory('param', [function(){
    return {
        kv:function(obj){
            var query = '', name, value, fullSubName, subName, subValue, innerObj, i;
            for(name in obj) {
                value = obj[name];
                
                if(value instanceof Array) {
                    for(i=0; i<value.length;i++){
                        subValue = value[i];
                        fullSubName = name + '[' + i + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                }
                else if(value instanceof Object) {
                    for(subName in value) {
                        subValue = value[subName];
                        fullSubName = name + '[' + subName + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                }
                else if(value !== undefined && value !== null){
                    query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
                }
            }
            return query.length ? query.substr(0, query.length - 1) : query;
        }
    }
    
}])


.factory('ajax', ['$http','param','$ionicLoading',function($http,param,$ionicLoading){
    var prefix_url='http://www.ijzh.cn:8080/GE/';
    // var prefix_url='http://192.168.68.10:10086/GE/';

    var transform = function(data){
        return param.kv(data);
    }
    return{
            
        tp:function(url,dat,type,notPrefix){
            if(!notPrefix){            
                url=prefix_url+url;
            }
            var content_type
            if(angular.isUndefined(type)||type=='json'){
                content_type={'Content-Type':'application/json;charset=UTF-8'};
            }else if(type=='kv'){
                content_type={'Content-Type':'application/x-www-form-urlencoded;charset=UTF-8'};
            }
            var param={
                method:'POST',
                url:url,
                data:dat,
                headers:content_type,
                // transformRequest:transform
            }

            var popTemplate


            if(type=='kv'){
                param.transformRequest=transform;
            }
            //打开全屏遮罩
            $ionicLoading.show({
                template: '<ion-spinner icon="lines" class="" style="fontsize:40px;color:#24a7cb"></ion-spinner>',
                noBackdrop:true,
                hideOnStateChange :true
            });
            var promise=$http(param);
            promise.then(function(){
                //关闭全屏遮罩
                $ionicLoading.hide();
            })
            return promise;
        },
        tg:function(url,dat,type){

        }
    } 

}]);

myService.factory('wordSearch', [function(){
    var conditionRepo;
    var allRepo;
    return {
        getConditionWord:function(){
            return this.conditionRepo;
        },
        setConditionWord:function(res){
            this.conditionRepo=res;
        },
        getAllWord:function(){
            return this.allRepo;
        },
        setAllWord:function(res){
            this.allRepo=res;
        }
    }
}]);

myService.factory('waveandwave', ['learning','paragraphInfo','$state','ajax','getWords',
    function(learning,paragraphInfo,$state,ajax,getWords){
    
    var wavetype='';
    var watchID = null;
    var oldX = 5, oldY = 5,oldZ=5,timestamp=0;
    var distance=0;
    var pendingDistance=20;
    var deviceStatus='waiting';  //这里状态应该有   waiting   waving  
    var audioObj;

    var onSuccess=function(newValue){
        // console.log('执行到onSuccess');
        diffX = Math.abs(newValue.x-oldX);
        diffY = Math.abs(newValue.y-oldY);
        diffZ = Math.abs(newValue.z-oldZ);
        timestamp = newValue.timestamp;
        distance=diffX+diffY+diffZ;
        // console.log(distance);

        if(distance>pendingDistance){
            if(deviceStatus!='waving'){
                startWave(newValue.x,newValue.y,newValue.z); //开始摇一摇特效
            }else{
                continueDoing(newValue.x,newValue.y,newValue.z,distance); //持续一部分特效
            }
        }else{
            if(deviceStatus=='waving'){
                stopWave(newValue.x,newValue.y,newValue.z,distance); // 停止摇一摇特效， 给出结果   改变deviceStatus标示为waiting
            }
        }

        //最后要把 新值传给旧值 供下一次使用
        oldX = newValue.x;
        oldY = newValue.y;
        oldZ = newValue.z;
    }

    var onError=function() {
        $cordovaDialogs.alert('onError!');
    }

    function startWave(x,y,z){
        // var accepsd =  'X: ' + x  + '/Y: ' + y + '/Z: ' + z ;
        //$cordovaDialogs.alert(accepsd)
        // var element = null;
        
        // var element = document.getElementById('accelerometer_div');
        // element.innerHTML = accepsd;

        deviceStatus='waving';
        audioObj.play();
        
    }
    function continueDoing(x,y,z,d){
        // var accepsd = "continueDoing:<br>"+ 'X: ' + x  + '/Y: ' + y + '/Z: ' + z +"<br>distance:"+d;
        // //$cordovaDialogs.alert(accepsd)
        // var element = document.getElementById('accelerometer_div');
        // element.innerHTML = accepsd;
        audioObj.play();
    }

    function stopWave(x,y,z,d){
        // alert('停止摇');
        // var accepsd = "stop:<br>"+ 'X: ' + x  + '/Y: ' + y + '/Z: ' + z +"<br>distance:"+d;
        // //$cordovaDialogs.alert(accepsd)
        // var element = document.getElementById('accelerometer_div');
        // element.innerHTML = accepsd;
        deviceStatus='waiting';
        // var element = document.getElementById('accelerometer_div');
        // element.innerHTML = '';
        if(wavetype=='paragraph'){
            // alert('停止摇一摇特效，');
            var _ajax=learning.listRandomParagraphs();
            _ajax.success(function(res){
                paragraphInfo.saveParagraph(res[0]);
                paragraphInfo.saveParagraphStatus(0);
                console.log('显示摇一摇段落');
                console.log(res[0]);
            });
        }else if(wavetype=='word'){
            // alert('停止单词的摇一摇');
            stopw();
            var url="listRandomWords.na";
            ajax.tp(url,{'num':10},'kv')
            .success(function(res){
                    // wordSearch.setConditionWord(res);
                    // $state.go('studingWord');
                console.log(res);
                getWords.saveWords(res);
                $state.go('wordPage');
            });
        }       
    }

    var startw=function(type){
        wavetype=type;
        console.log(wavetype);
        if(wavetype=='word'){
            audioObj=angular.element(document.getElementById('waveWordAudio'))[0];
        }else if(wavetype=='paragraph'){
            audioObj=angular.element(document.getElementById('waveParaAudio'))[0];
        }
        var options = { frequency: 300 };
        watchID = navigator.accelerometer.watchAcceleration(onSuccess, onError, options);
    }

    var stopw=function(){
        if (watchID) {
            navigator.accelerometer.clearWatch(watchID); watchID = null;
        }
    }
    return  {
        startWatch:function(type){
            startw(type);
        },
        stopWatch:function(){

            stopw();
        }
    }
}]);

myService.factory('getGPS', ['$cordovaGeolocation',
    function($cordovaGeolocation){
    var watchID='';

    function onError(error) {
        alert('code: ' + error.code + '\n' + 'message: ' + error.message + '\n');
        switch(error.code)
        {
            case 1:
            alert('您拒绝了使用位置共享服务，请手动输入您的就餐地址。!');
            break;
            default :
            alert('获取位置失败，请手动输入您的就餐地址。!');
            break;
        }
    }

    var nowGps=function(position){
        console.log('使用nowGPS')
        var pos={
            'latitude':position.coords.latitude,
            'longtitude':position.coords.longtitude,
            'altitude':position.corrds.altitude
        }
        alert(position.coords.latitude);
        stopWatch();
        console.log(pos);
        return pos;
    }
    return {
        startWatch:function(){
            // console.log($cordovaGeolocation);
            // watchID=$cordovaGeolocation.getCurrentPosition(nowGps,onError,{enableHighAccuracy:true});
            var obj=$cordovaGeolocation.getCurrentPosition({enableHighAccuracy:true});
            obj.then(function(position){
                console.log('onSuccess');
                alert(position.coords.latitude);
                console.log(position);
            },function(onerror){
                alert('onerror');
                console.log(onerror);
            })
        },
        stopWatch:function(){
            if(watchID!=''){
                $cordovaGeolocation.clearWatch(watchID);
            }
        }
    };
}])

myService.factory('autoLogin', ['userinfo','$cordovaDevice','$window','ajax','$rootScope',function(userinfo,$cordovaDevice,$window,ajax,$rootScope){



    return function(){
        var uuid = $cordovaDevice.getUUID();
        $window.localStorage['deviceCode']=uuid;
        // alert(uuid);
        console.log(uuid);
        console.log('运行到autoLogin');
        // console.log(this.user);
        // return this.user;
        var user;
        var deviceCode=$window.localStorage['deviceCode'];
        if(!deviceCode){
            // alert('不可能是这里');
            //从cordova device插件中获取 deviceCode  并且要注册一个deviceCode的账号
            deviceCode=$cordovaDevice.getUUID()||$window.localStorage['deviceCode'];
            var _dat={'deviceCode':deviceCode};
            var url="registerWithDevice.na";
            ajax.tp(url,_dat,'kv')
            .success(function(res){
                console.log('以下是deviceCode注册返回信息')
                console.log(res);
                $window.localStorage['deviceCode']=deviceCode;
            });
        }
        var account=$window.localStorage['account'];
        var password=$window.localStorage['password'];

        if(account&&password){
            // alert('1');

            var _dat={'accountName':account,'password':password};
            var url="loginWithPassword.na";
            ajax.tp(url,_dat,'kv')
            .success(function(res){
                console.log('以下信息是account登陆信息');
                // console.log(res);
                if(res.success==true){
                    this.user=res.content;
                    $window.localStorage['account']=account;
                    $window.localStorage['password']=password;
                    // console.log(this.user);
                    // return this.user;
                    $rootScope.$broadcast('userinfoChanged',this.user);
                }
            });
        }else{
            // alert('2');

            var _dat={'deviceCode':deviceCode};
            var url="loginWithDevice.na";
                console.log(_dat);

            ajax.tp(url,_dat,'kv').
            success(function(res){
                // alert('3');

                console.log('以下信息是deviceCode登陆信息');
                if(res.success==true){
                    this.user=res.content;
                    // return this.user;
                    userinfo.saveUser(res.content);
                    // alert(4);
                    $rootScope.$broadcast('userinfoChanged',this.user);
                }
                // console.log(res);

            });
        }



    };
   
}]);


myService.factory('userinfo', ['$window', function($window){
    var userInfo
    return {
        saveUser:function(dat){
            console.log('储存账户信息');
            userInfo=dat;
            $window.localStorage['userInfo']=angular.toJson(userInfo);
        },
        getUser:function(){
            // if(!this.userinfo){
                userInfo=$window.localStorage['userInfo'];
                // console.log('userInfo信息如下');
                // console.log(userInfo);
                userInfo=angular.fromJson(userInfo);
            // }
            return userInfo;
        },
        saveAP:function(account,password){
            $window.localStorage['account']=account;
            $window.localStorage['password']=password;
        },
        getLoignPassword:function(){
            return $window.localStorage.getItem('password');
        }

    };
}]);

myService.factory('getWords', ['ajax','$window', function(ajax,$window){
    var words='';
    return {
        saveWords:function(res){
            words=res;
            $window.localStorage['words']=angular.toJson(res);
        },
        random:function(condition){

        },
        conditional:function(){

            if(words==''){
                words=angular.fromJson($window.localStorage['words']);
            }
            return words;
        }
    };
}]);

myService.factory('paragraphInfo', ['ajax','$window','$rootScope',function(ajax,$window,$rootScope){
    var s='';
    var p='';
    return {
        saveParagraph:function(res){
            p=res;
            $window.localStorage['paragraph']=angular.toJson(res);
            $rootScope.$broadcast('paragraphChanged',p);
        },
        getParagraph:function(){
            if(p==''){
                p=angular.fromJson($window.localStorage['paragraph']);
            }
            return p;
        },
        saveParagraphStatus:function(status){
            s=status;
        },
        getParagraphStatus:function(){
            return s?s:0;
        }
    }
}]);

myService.factory('articleInfo', ['ajax','$window','$rootScope', function(ajax,$window,$rootScope){
    var status='';
    var article='';
    var articleAction='';

    return {
        saveArticle:function(res){
            console.log('储存文章');
            article=res;
            $window.localStorage['article']=angular.toJson(res);
            $rootScope.$broadcast('articleChanged',res);
        },
        getArticle:function(){
            if(article==''){
                article=angular.fromJson($window.localStorage['article']);
            }
            return article;
        },
        saveArticleStatus:function(sta){
            status=sta;
        },
        getArticleStatus:function(){
            return status?status:0;
        },
        saveArticleAction:function(res){
            articleAction=res;
            $window.localStorage['nowArticleAction']=angular.toJson(res);
        },
        getArticleAction:function(){
            if(articleAction==''){
                articleAction=angular.fromJson($window.localStorage['nowArticleAction']);
            }   
            return articleAction;
        }
    }
}])

myService.factory('sentenceInfo', ['ajax','$window','$rootScope', function(ajax,$window,$rootScope){
    var status='';
    var sentence='';
    var sentenceAction='';
    return {
        saveSentence:function(res){
            console.log('储存句子');
            sentence=res;
            $window.localStorage['sentence']=angular.toJson(res);
            $rootScope.$broadcast('sentenceChanged',res);
        },
        getSentence:function(){
            if(sentence==''){
                sentence=angular.fromJson($window.localStorage['sentence']);
            }
            return sentence;
        },
        saveSentenceStatus:function(sta){
            status=sta;
        },
        getSentenceStatus:function(){
            return status?status:0;
        },
        saveSentenceAction:function(res){
            console.log('储存句子action');
            sentenceAction=res;
            $window.localStorage['nowSentenceAction']=angular.toJson(res);
        },
        getSentenceAction:function(){
            if(sentenceAction==''){
                sentenceAction=angular.fromJson($window.localStorage['nowSentenceAction']);
            }   
            return sentenceAction;
        }
    };
    
}])

myService.factory('getLocation', [function(){
    return function name(){
        
    };
}]);

myService.factory('wordsStatus', ['$window', function($window){
    return {
        saveStatus:function(status){
            //status  的值有0不保留状态  1保留状态   
            $window.localStorage['wordsStatus']=status;
        },
        getStatus:function(){
            return $window.localStorage['wordsStatus']||0;
        }
    }
}]);

myService.factory('learning', ['ajax','$window','$state','$ionicPopup', function(ajax,$window,$state,$ionicPopup){
    return {
        startWordLearning:function(num,wid,loc,uid){
            var url='startWordLearning.na';
            var _dat={'target.id':wid,'record.location':loc,'executor.id':uid};
            ajax.tp(url,_dat,'kv')
            .success(function(res){
                if(res.success=true){
                    $window.localStorage['nowWordActionId.'+num]=angular.toJson(res.content); //对于单词学习 获取一个开始学习的actionid
                }
            })
            .error(function(res){
                console.log('失败了')
            });
        },
        updateWordLearningDuration:function(actionid,timer){
            // $window.localStorage['nowActionId']; //读取目前正在进行的操作actionid  全局app此id为唯一变量
            var url="updateWordLearningDuration.na";
            var _dat={'action.id':actionid,'duration':timer};
            ajax.tp(url,_dat,'kv')
            .success(function(res){
                console.log('测试测试updateWordLearningDuration');
                // console.log(res);
            });
        },
        //单词题目选项排除
        addWordLearningQuestionOptionOperation:function(actionId,qid,optionId,operate,reason){
            var url="addWordLearningQuestionOptionOperation.na";
            var dat={'behaviour.action.id':actionId,'question.id':qid,'operateTarget.id':optionId,'operate':operate,'reason':reason};
            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log('记录句子选择题的操作');
                console.log(res);

           });
        },
        //获取随机的段落
        listRandomParagraphs:function(){
            var url="listRandomParagraphs.na";
            var _dat={'num':1}
            return ajax.tp(url,_dat,'kv')
        },
        //开始段落学习
        startParagraphLearning:function(pid,loc,uid,direct,from){
            var url="startParagraphLearning.na";
            var dat={'target.id':pid,'record.location':loc,'executor.id':uid}
            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log('开始段落学习');
                console.log(res);
                console.log('页面准备跳转');
                if(res.success=true){
                    $window.localStorage['nowParagraphAction']=angular.toJson(res.content); 
                }
                if(direct!=''&&!angular.isUndefined(direct)){
                    if(from!=''&&!angular.isUndefined(from)){
                        $state.go('paragraph',{'from':from});
                    }else{
                        $state.go('paragraph');
                    }
                }
            });
            
        },
        //更新段落学习时间
        updateParagraphLearningDuration:function(timer,actionId){
            var url="updateParagraphLearningDuration.na";
            var dat={'duration':timer,'action.id':actionId};
            ajax.tp(url,dat,'kv')
            .success(function(res) {
                console.log('更新段落学习时间');
                console.log(res);
            });
        },
        //更新段落模拟题答案
        addParagraphLearningSimulatedSingleAnswerQuestionAnswer:function(qid,optionId,isCorrect,actionId){
            var url="addParagraphLearningSimulatedSingleAnswerQuestionAnswer.na";
            var dat={'question.id':qid,'userAnswer.id':optionId,'isCorrect':isCorrect,'result.action.id':actionId};
            return ajax.tp(url,dat,'kv')
            
        },
        //用户对段落模拟题选项的操作
        addParagraphLearningSimulatedSingleAnswerQuestionOptionOperation:function(actionId,qid,optionId,operate,reason){
            var url="addParagraphLearningSimulatedSingleAnswerQuestionOptionOperation.na";
            var dat={'behaviour.action.id':actionId,'operate':operate,'reason':reason,'question.id':qid,'operateTarget.id':optionId}

            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log('记录段落模拟题的操作');
                console.log(res);
            });
        },
        //创建句子学习
        startSentenceLearning:function(sid,loc,uid){
            var url="startSentenceLearning.na";
            var dat={'target.id':sid,'record.location':loc,'executor.id':uid};
            return ajax.tp(url,dat,'kv');
        },
        updateSentenceLearningDuration:function(timer,actionId){
            var url="updateSentenceLearningDuration.na";
            var dat={'duration':timer,'action.id':actionId};
            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log('更新此句子学习时间');
                console.log(res);
            });
        },
        addSentenceLearningSimulatedSingleAnswerQuestionAnswer:function(qid,optionId,isCorrect,actionId,descr){
            var url="addSentenceLearningSimulatedSingleAnswerQuestionAnswer.na";
            var dat={'question.id':qid,'userAnswer.id':optionId,'descr':descr,'isCorrect':isCorrect,'result.action.id':actionId};
            return ajax.tp(url,dat,'kv');
            
        },
        addSentenceLearningSimulatedFillInQuestionAnswer:function(qid,fillin,isCorrect,actionId,descr){
            var url='addSentenceLearningSimulatedFillInQuestionAnswer.na';
            var dat={'question.id':qid,'userAnswer.id':fillin,'descr':descr,'isCorrect':isCorrect,'result.action.id':actionId};
            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log('更新句子填空题答案');
                console.log(res);
                $ionicPopup.alert({title:'自学君提示您',template:'提交答案成功'})

            });
        },
        addSentenceLearningSimulatedSingleAnswerQuestionOptionOperation:function(actionId,qid,optionId,operate,reason){
            var url="addSentenceLearningSimulatedSingleAnswerQuestionOptionOperation.na";
            var dat={'behaviour.action.id':actionId,'question.id':qid,'operateTarget.id':optionId,'operate':operate,'reason':reason};
            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log('记录句子选择题的操作');
                console.log(res);

            });
        },
        //获取指定文章
        getReleasedArticle:function(aid){
            var url="getReleasedArticle.na";
            var dat={id:aid};
            console.log('开始了');
            return ajax.tp(url,dat,'kv')
           
        },
        //获取文章列表
        getReleasedArticleList:function(num){
            var url="getInUseReleasedArticles.na";
            var dat={size:8,page:num}
            return ajax.tp(url,dat,'kv')
        },
        startArticleLearning:function(aid,uid,loc){
            var url="startArticleLearning.na";
            var dat={'target.id':aid,'record.location':loc,'executor.id':uid};
            return ajax.tp(url,dat,'kv');
        },
        updateArticleLearningDuration:function(timer,actionId){
            console.log(timer);
            console.log(actionId);
            var url="updateArticleLearningDuration.na";
            var dat={'duration':timer,'action.id':actionId};
            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log(res);
            })
        },
        addArticleLearningPastSingleAnswerQuestionAnswer:function(qid,optionId,isCorrect,actionId,descr){
            var url="addArticleLearningPastSingleAnswerQuestionAnswer.na";
            var dat={'question.id':qid,'userAnswer.id':optionId,'isCorrect':isCorrect,'result.action.id':actionId,'descr':descr}
            console.log(dat);
            return ajax.tp(url,dat,'kv');
            
        },
        addArticleLearningPastSingleAnswerQuestionOptionOperation:function(actionId,qid,optionId,operate,reason){
            var url="addArticleLearningPastSingleAnswerQuestionOptionOperation.na";
            var dat={'behaviour.action.id':actionId,'question.id':qid,'operateTarget.id':optionId,'operate':operate,'reason':reason};
            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log('记录真题的排除操作');
                console.log(res);
            })
        }

    }
}]);
//时间戳服务
myService.factory('getTimestamp', [function(){
    return function(){
         return Date.parse(new Date())/1000;
    }
}]);

//自我测评状态
myService.factory('evaluateInfo', ['ajax','$window', function(){
    var evaluate='';
    var status='';
    var evaluateLearning='';

    return {
        saveEvalute:function(res){
            evaluate=res;
            $window.localStorage['evaluate']=angular.toJson(res);
        },
        getEvaluate:function(){
            if(evaluate==''){
                evaluate=angular.fromJson($window.localStorage['evaluate']);
            }
            return evaluate;
        },
        saveEvaluateStatus:function(sta){
            status=sta;
            angular.localStorage['evaluateStatus']=sta;
        },
        getEvaluateStatus:function(){
            if(status==''){
                status=angular.fromJson($window.localStorage['evaluateStatus']);
            }
            return status;
        },
        saveEvaluateLearning:function(learning){
            evaluateLearning=learning;
        },
        getEvaluateLearning:function(){
            return evaluateLearning;
        }
    }
}])


//自我测评
myService.factory('selfEvaluate', ['ajax','$ionicPopup','getTimestamp','evaluateInfo', function(ajax,$ionicPopup,getTimestamp,evaluateInfo){
    return {
        //获取自我测评的试卷
        listRandomSelfExams:function(){
            var url="listRandomSelfExams.na";
            var dat={num:1};
            return ajax.tp(url,dat,'kv');
        },
        //开始自我测评的学习，这2个似乎应该在一起调用，或者直接写在一起
        startSelfExamination:function(eid,uid,loc){
            var url="startSelfExamination.na";
            var dat={'target.id':eid,'executor.id':uid,'record.location':loc}
            return ajax.tp(url,dat,'kv')
            
        },
        //记录题目的答案
        addSelfEvaluateQuestionAnswer:function(type,qid,uid,isCorrect,actionId){
            var url='';
            if(angular.isUndefined(type)){
                type=='word';
            }
            if(type=='word'){
                url="addSelfExaminationWordBasedSimulatedSingleAnswerQuestionAnswer.na";
            }else if(type=='para'){
                url="addSelfExaminationParagraphBasedSimulatedSingleAnswerQuestionAnswer.na"
            }
            var dat={
                'question.id':qid,
                'userAnswer.id':uid,
                'isCorrect':isCorrect,
                'result.action.id':actionId
            };
            return ajax.tp(url,dat,'kv')
            
        },
        //记录该次评测的时间
        updateSelfEvaluateDuration:function(actionId){
            var timer=getTimestamp();
            var url="updateSelfExaminationDuration.na"
            var dat={'duration':timer,'action.id':actionId}
            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log('记录此次自我评测时间戳');
                console.log(res);
            });
        },

        addSelfExaminationSingleAnswerQuestionOptionOperation:function(actionId,qid,optionId,operate,reason,type){
            if(type=="word"){
                var url="addSelfExaminationWordBasedSingleAnswerQuestionOptionOperation.na";
            }else if(type=='paragraph'){
                var url="addSelfExaminationParagraphBasedSimulatedSingleAnswerQuestionOptionOperation.na"
            }
            var dat={'behaviour.action.id':actionId,'question.id':qid,'operateTarget.id':optionId,'operate':operate,'reason':reason};
            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log('记录句子选择题的操作');
                console.log(res);

            });
        }


        
    }
}])



myService.factory('countTimer',['$interval',function($interval){
    var _temp;
    var _tempArr;
    var timer=0;
    var timerArr=[];
    return {
        //阅读和段落的计时
        startTimer:function(){
            _temp=$interval(function(){
                timer=parseInt(timer)+1;
            },1000);
        },
        stopTimer:function(){
            $interval.cancel(_temp);
        },
        clearTimer:function(){
            timer=0;
            this.stopTimer();
        },
        getTimer:function(){
            return timer;
        },
        //单词词组的计时
        initTimerArr:function(len){
            for(var i=0;i<len;i++){
                timerArr[i]=0;
            }
        },
        startTimerArr:function(index){
            _tempArr=$interval(function(){
                timerArr[index]=parseInt(timerArr[index])+1;
            },1000);
        },
        stopTimerArr:function(index){
            $interval.cancel(_tempArr);
        },
        clearTimerArr:function(index){
            timerArr[index]=0;
            this.stopTimerArr(index);
        },
        getTimerArr:function(){
            return timerArr;
        }
    }
}]);

myService.factory('evaluateResult', ['misc','ajax','userinfo','$q','$templateRequest',
    function(misc,ajax,userinfo,$q,$templateRequest){
    var eva=[];
    // var result=[];
    var result={};
    var user=userinfo.getUser();
    var based={

    };
    // var makeRecord=function(){

    // }
    return {
        makeBase:function(){

        },
        saveResult:function(obj){
            // console.log('eva目前值');
            // console.log(eva);
            console.log('下面是传入的对象');
            console.log(obj);
            var add=true;
            //应该传入一个对象  键名字为题目的id，值为对错，或者还应该带有选项的ID或者填空的答案
            angular.forEach(eva,function(va,k){
                if(va.id==obj.id&&va.myType==obj.myType){
                    eva[k]=obj;
                    add=false;
                }
            });
            if(add){
                eva.push(obj);
            }
            // console.log('最终eva');
            // console.log(eva);
        },
        getResultForErrorQuestions:function(){
            return eva;
        },
        getResult:function(uid){
            var len=eva.length;
            var trueNum=0;
            var falseNum=0;
            var paraCorrect='';
            var wordCorrect='';
            var articleCorrect='';
            var paraQuestionNum=0;
            var totalRate='';
            var paraRate='';
            var articleRate='';
            var wordRate='';
            var score='';
            var paraText='';
            var wordText='';
            var articleText='';
            var wordArr=[];
            var paragraphArr=[];
            var sentenceArr=[];
            var articleArr=[];
            //这里要插入一条从远程引入的逻辑

            angular.forEach(eva,function(va,k){

                //这里要处理actionid 并装进相应的数组中
                switch(va.myType){
                    case 'word':
                        if(wordCorrect==''){
                            wordCorrect=0;
                        }
                        wordArr.push(va.actionid);
                        break;
                    case 'para':
                        if(paraCorrect==''){
                            paraCorrect=0;
                        }
                        var notAdd=true;
                        angular.forEach(paragraphArr,function(sv,sk){
                            if(va.actionid==sv){
                                paragraphArr[sk]=va.actionid;
                                notAdd=false;
                            }
                        });
                        if(notAdd){
                            paragraphArr.push(va.actionid);
                        }
                        break;
                    case 'sentence':
                        if(paraCorrect==''){
                            paraCorrect=0;
                        }
                        // console.log(sentenceArr);
                        var notAdd=true;
                        angular.forEach(sentenceArr,function(sv,sk){
                            if(!(sv>=0)){
                                notAdd=false;
                            }
                            if(va.actionid==sv){
                                // sentenceArr[sk]=va.actionid;
                                notAdd=false;
                            }
                        });
                        if(notAdd){
                            sentenceArr.push(va.actionid);
                        }
                        break;
                    case 'article':
                        // console.log('switch article');
                        if(articleCorrect==''){
                            articleCorrect=0;
                        }
                        var notAdd=true;
                        angular.forEach(articleArr,function(sv,sk){
                            // console.log(sv);
                            if(va.actionid==sv){
                                articleArr[sk]=va.actionid;
                                notAdd=false;
                            }
                        });
                        if(notAdd){
                            articleArr.push(va.actionid);
                        }
                        break;
                }

                if(va.myType=='para'||va.myType=='sentence'){
                    paraQuestionNum++;
                }
                if(va.isCorrect){
                    trueNum++;
                    if(va.myType=='para'||va.myType=='sentence'){
                        
                        paraCorrect++;
                    }else if(va.myType=='word'){
                        
                        wordCorrect++;
                    }else if(va.myType=='article'){
                        
                        articleCorrect++;
                    }
                }else{
                    falseNum++;
                }
            });


            // console.log(articleArr);

            angular.forEach(articleArr,function(va,k){
                result["alActions["+k+"].id"]=va;
            });

            angular.forEach(wordArr,function(va,k){
                result['wlActions['+k+'].id']=va;
            });

            angular.forEach(paragraphArr,function(va,k){
                result['plActions['+k+'].id']=va;
            });

            angular.forEach(sentenceArr,function(va,k){
                result['slActions['+k+'].id']=va;
            });

            console.log(wordCorrect);
            totalRate=(trueNum/len)*100;
            if(totalRate.toString().leng>5){
                totalRate=totalRate.toString().substr(0,5);
            }
            if(paraCorrect!=''){
                paraRate=(paraCorrect/len)*100;
            }else{
                paraRate=parseInt(paraCorrect);
            }
            if(articleCorrect!=''){
                articleRate=(articleCorrect/(len-paraQuestionNum))*100
            }else{
                articleRate=parseInt(articleCorrect);
            }
            if(wordCorrect!=''){
                wordRate=(wordCorrect/(len-paraQuestionNum))*100;
            }else{
                wordRate=parseInt(wordCorrect);
            }
            //这里根据需要添加分数对应的映射
            if(totalRate<30){
                score='<40分';
            }else if(totalRate>=30&&totalRate<50){
                score='40--50分';
            }else if(totalRate>=50&&totalRate<65){
                score='50--62分';
            }else if(totalRate>=65&&totalRate<80){
                score='62--72分';
            }else if(totalRate>=80&&totalRate<100){
                score='72--85分';
            }else{
                score='>85分';
            }

            if(paraRate>=0){
                if(paraRate<30){
                    paraText='<12分';
                }else if(paraRate>=30&&paraRate<50){
                    paraText='12--20分';
                }else if(paraRate>=50&&paraRate<65){
                    paraText='20--25分';
                }else if(paraRate>=65&&paraRate<80){
                    paraText='25--32分';
                }else if(paraRate>=80&&paraRate<100){
                    paraText='32--39分';
                }else{
                    paraText='40分';
                }
            }

            if (wordRate>=0) {
                if(wordRate<33){
                    var _t='三星';
                }else if(wordRate>=33&&wordRate<66){
                    var _t='四星';
                }else{
                    var _t='五星';
                }
                wordText=misc.giveStar(_t,{'class':'energized'});
            }

            //新增文章部门的计算 并要在showResult中去显示

            // result={
            result['executor.id']=uid; //从调用的地方传过来
            result['totalAccuracy']=totalRate;
            result['paraAccuracy']=paraRate;
            result['wordAccuracy']=wordRate;
            result['artAccuracy']=articleRate;
            result['totalScore']=score;
            result['wlScore']=wordText;
            result['plScore']=paraText;
            result['alScore']=articleText;
          
            if(totalRate>=0){
                ajax.tp('addNewActionGroup.na',result,'kv');
            }
            return result;
        },
        prepareEva:function(arr,testType){
            eva=[];
            console.log('显示传过来d值')
            console.log(arr);
            angular.forEach(arr,function(va,k){
                var _t={};
                if(testType=='word'){
                    _t.id=va[0].id;
                    _t.actionid=parseInt(va[0].actionid);

                }else{
                    _t.id=va.id;
                    _t.actionid=parseInt(va.actionid);
                }
                _t.opid='';
                _t.isCorrect=false;
                if(testType=='eva'){
                    _t.myType=va.myType||'word';
                }else if(testType=='paraAndSen'){
                    _t.myType=va.myType||'para';
                }else{
                    _t.myType=testType;
                }
                _t.questionType=va.questionType;
                eva.push(_t);
            });
            console.log('初始化报告base');
            console.log(eva);
        },
        clearResult:function(){
            eva=[];
            result={};
        },
        getEvaluateResultEamil:function(result,emailAddress){
            function start(str){
                var defer=$q.defer();
                if(str!=''){
                    defer.resolve(str);
                }else{
                    defer.reject('');
                }
                return defer.promise;
            }

            function base64encode(str){  
                var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
                var out, i, len;  


                var c1, c2, c3;  
                len = str.length;  
                i = 0;  
                out = "";  
                while (i < len) {  
                    c1 = str.charCodeAt(i++) & 0xff;  
                    if (i == len) {  
                        out += base64EncodeChars.charAt(c1 >> 2);  
                        out += base64EncodeChars.charAt((c1 & 0x3) << 4);  
                        out += "==";  
                        break;  
                    }  
                    c2 = str.charCodeAt(i++);  
                    if (i == len) {  
                        out += base64EncodeChars.charAt(c1 >> 2);  
                        out += base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));  
                        out += base64EncodeChars.charAt((c2 & 0xF) << 2);  
                        out += "=";  
                        break;  
                    }  
                    c3 = str.charCodeAt(i++);  
                    out += base64EncodeChars.charAt(c1 >> 2);  
                    out += base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));  
                    out += base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6));  
                    out += base64EncodeChars.charAt(c3 & 0x3F);  
                }  
                return out;  
            } 

            function sendMail(content){
                if(!angular.isUndefined(emailAddress)){
                    var title=user.accountName+'的学习邮件通知';
                    var dat={'appid':1,'sign':2,'to':emailAddress,'title':title,'body':content};
                    // console.log(base64encode('<div>1</div>'));
                    misc.sendMail(emailAddress,title,'<div>1</div>');
                    // ajax.tp('http://192.168.4.12:8009/A2apis/SendEmail',dat,'kv',true);
                }
            }

            var promise;
            promise=start('templates/emailHeader.html')
            .then(function(str){
                return $templateRequest(str).then(function(header){
                    emailHeader=header;
                    return start('templates/email.html');
                });
            }).then(function(str){
                var _type='';
                if(result.paraAccuracy>=0){
                    _type='随手学阅读';
                }else if(result.wordAccuracy>=0){
                    _type='轻松学单词';
                }else if(result.artAccuracy>=0){
                    _type='认真刷真题';
                }
                emailBody="<div class='email-warp'>";
                emailBody+="<div class='email-titte'>自学君"+user.accountName+"的学习邮件通知</div>";
                emailBody+="<div class='STYLE1'>"+_type+"</div>";
                emailBody+="<div class='time'><span>时&nbsp;&nbsp;&nbsp;间："+misc.getNowTime()+"</span></div>";
                emailBody+="<div class='time'><span>2017年英语得分："+result.totalScore+"</span></div>";
                if(result.paraAccuracy>=0){
                    emailBody+="<div class='time'><span>阅读理解得分："+result.plScore+"%</span></div>";
                }
                if(result.artAccuracy>=0){
                    emailBody+="<div class='time'><span>单词得分："+result.wlScore+"%</span></div>";
                }
                emailBody+="</div>";
                return start('templates/emailFooter.html');
            }).then(function(str){
                $templateRequest(str).then(function(footer){
                    emailFooter=footer;
                    // $timeout(function(){
                        text=emailHeader+emailBody+emailFooter;
                        console.log(text);
                        sendMail(text);
                    // },1000);
                    // return text;
                })
            });
        }

    }
}]);

myService.factory('radialIndicatorInstance', function () {
    if (!window.radialIndicator) throw "Please include radialIndicator.js";

    var radialIndicatorInstance = {};

    return radialIndicatorInstance;

});

myService.factory('shuffle', [function(){
    return function(arr){
        if(!angular.isArray(arr)){
            return arr;
        }else{
            var iLength = arr.length,
                i = iLength,
                mTemp,
                iRandom;
            while(i--){
                if(i !== (iRandom = Math.floor(Math.random() * iLength))){
                    mTemp = arr[i];
                    arr[i] = arr[iRandom];
                    arr[iRandom] = mTemp;
                }
            }
            return arr;
        }
    }
}]);

myService.factory('misc', ['ajax','userinfo','$ionicPopup','$state',
    function(ajax,userinfo,$ionicPopup,$state){

    var user=userinfo.getUser();
    return {
        giveStar:function(str,option){
            // console.log(str);
            if(angular.isObject(option)){
                op=option
            }else{
                op={}
            }
            var icon='<span style="color:'+op.color+'" class="'+op.class+'">';
            var star={
                '一星':1,
                '二星':2,
                '三星':3,
                '四星':4,
                '五星':5,
            }
            for(var i=0;i<star[str];i++){
                icon+="<i class='icon ion-star'></i>";
            }
            icon+="</span>";
            return icon;
        },
        getLeftDays:function(){
            var url="untilDeadLine.na";
            var dat={};
            return ajax.tp(url,dat,'kv');

        },
        getLearningProcess:function(viewed,total){
            return (viewed/total)*100;
        },
        devideEmail:function(str){
            var emails=[];
            if(!angular.isUndefined(str)&&str!=null){
                if(str.indexOf(',')){
                    emails=str.split(',');
                }
            }
            return emails;
        },
        getAccountRank:function(id){
            var url="getAccountRank.na";
            var dat={'id':id};
            return ajax.tp(url,dat,'kv');
        },
        raiseErrorMessage:function(json){
            /* raiser.id    part    year    subject 
            *   target      descr   errorDescr
            */


            var url="raiseErrorMessage.na";
            var dat={'raiser.id':user.id,'part':json.part,'year':json.year,'subject':json.subject,'errorDescr':json.errorDescr,'target':json.target,'descr':json.descr};
            console.log(dat);
            ajax.tp(url,dat,'kv')
            .success(function(res){
                console.log(res);
                if(res.success==true){
                    $ionicPopup.alert({
                        title:'自学君提示您',
                        template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>感谢您的提交</span>",
                        buttons:[{
                            text:'朕知道了',
                            type:'button-xdf',
                        }]
                    })
                }
            });
        },
        getNowTime:function(){
            var _m=new Date();
            var _s=_m.getFullYear()+'-'+(_m.getMonth()+1)+'-'+_m.getDate()+' '+_m.getHours()+':'+_m.getMinutes()+':'+_m.getSeconds();
            return _s;
        },
        giveRegisterHint:function(){
            console.log(user);
            if(user.accountName==null){
                $ionicPopup.alert({
                    title:'自学君提示您',
                    template:"<span class='zhf_bianda'>您还没有注册成为正式账号，请尽快注册以便使用全部功能。</span>",
                    buttons:[{
                        text:'朕知道了',
                        type:'button,button-xdf'
                    },{
                        text:'去注册',
                        type:'button,button-xdf',
                        onTap:function(){
                            $state.go('loginRegist');
                        }
                    }]
                })
            }
        },
        sendMail:function(to,title,content){
            var url="sendMail.na";
            dat={'to':to,'title':title,'content':content};
            return ajax.tp(url,dat,'kv')
        }

    }
}])

myService.factory('questionsResult', ['ajax','DB',function(ajax,DB){
    var body;
    var select;

    return {
        saveBody:function(res){
            body=res;
        },
        saveSelect:function(res){
            select=res;
        },
        getBody:function(){
            return body;
        },
        getSelect:function(){
            return select;
        }

    }
}])

myService.factory('DB', [function(){
    var myDB;
    return{
        myDB:myDB,
        openDB :function (name,version) {
            // var version=version || 1;
            // var request=window.indexedDB.open(name,version);
            // request.onerror=function(e){
            //     console.log(e.currentTarget.error.message);
            // };
            // request.onsuccess=function(e){
            //     myDB=e.target.result;
            // };
            // request.onupgradeneeded=function(e){
            //     console.log('DB version changed to '+version);
            // };
        },

        closeDB:function(db){
            db.close();
        },

        deleteDB:function(name){
            indexedDB.deleteDatabase(name);
        },

    }
}])

myService.factory('tempSave', ['$window', function(){
    var tempData={};

    return {
        saveData:function(k,va){
            tempData[k]=va;
        },
        getData:function(k){
            return tempData[k];
        },
        clearData:function(k){
            tempData[k]=undefined;
        },
        clearDataAll:function(){
            tempData={};
        }
    }
}])

myService.factory('ngtest', ['$compile','$ionicBackdrop','$ionicLoading',function($compile,$ionicBackdrop,$ionicLoading){
    return {
        start:function(){

            var ic=document.getElementsByTagName('ion-content');
            var iv=document.getElementsByTagName('ion-view');
            if((!angular.isUndefined(ic))&&ic.length){
                ic=ic[0];
            }
            if((!angular.isUndefined(iv))&&iv.length){
                iv=iv[0];
            }
            var aic=angular.element(ic);
            // aic=aic[0];
            console.log(aic);
            console.log(aic[0].clientHeight);
            console.log(aic[0].clientWidth);

            // var html='<frontCover ng-test-cover style="position:absolute;height:'+'300'+'px;width:'+'200'+'px;background-color:gray;"></div>';
            var _div=document.createElement('frontCover');
            var _c=document.createElement('ion-spinner');

            _div.setAttribute('ng-test-cover','');
            _div.style.position='absolute';
            _div.style.height=aic[0].clientHeight+'px';
            _div.style.width=aic[0].clientWidth+'px';
            _div.style.backgroundColor='gray';
            _div.style.opacity=0.6;
            console.log(aic);
            _div.appendChild(_c);
            iv.appendChild(_div);
            
        },
        stop:function(){
            // var ic=document.getElementsByTagName('ion-content');
            // if((!angular.isUndefined(ic))&&ic.length){
            //     ic=ic[0];
            // }
            var fc=document.getElementsByTagName('frontCover');
                console.log(fc);
            fc[0].remove();
            // ic.removeChild(fc);
        },
        sb:function(){
            // $ionicBackdrop._element[0].innerHTML='<ion-spinner icon="spiral"></ion-spinner>';
            // var a=$ionicBackdrop._element;
            // console.log(a);
            // $ionicBackdrop.retain();
            $ionicLoading.show({
                template: '<ion-spinner icon="android" class="spinner-royal"></ion-spinner>',
                noBackdrop:true,
                hideOnStateChange :true
            }).then(function(){
               console.log("The loading indicator is now displayed");
            });

        },
        st:function(){
            $ionicLoading.hide().then(function(){
                console.log("The loading indicator is now hidden");
            });
            // $ionicBackdrop.release();
        }
    }


    
}])

myService.factory('findPictureByStatus', ['ajax', function(ajax){
    var url="findPictureByStatus.na";
    var dat={'status':'SPECIFIED'};
    return function(){
        return ajax.tp(url,dat,'kv')
    }
}])

myService.factory('habbit',['$window',function($window){
    var startNames=['phase11Start','phase12Start','phase13Start'];
    var endNames=['phase11End','phase12End','phase13End'];
    var start={};
    var end={};
    return {
        saveStart:function(key,res){
            angular.forEach(startNames,function(va,k){
                if(key==va){
                    $window.localStorage[va]=res;
                    // break;
                }
            });
        },
        getStart:function(){
            angular.forEach(startNames,function(va,k){
                start[va]=$window.localStorage[va]||'';
            });
            return start;
        },
        saveEnd:function(key,res){
            angular.forEach(endNames,function(va,k){
                if(key==va){
                    $window.localStorage[va]=res;
                    // break;
                }
            });
        },
        getEnd:function(){
            angular.forEach(endNames,function(va,k){
                end[va]=$window.localStorage[va]||'';
            });
            return end;
        },
        clearAll:function(){
            angular.forEach(startNames,function(va,k){
                $window.localStorage[va]='';
            });
            angular.forEach(endNames,function(va,k){
                $window.localStorage[va]='';
            });
        },
        setNowHabbit:function(){

        },
        getNowHabbit:function(){

        }
    }

}])

myService.factory('proActions', ['ajax','userinfo',function(ajax,userinfo){
    var uid=userinfo.getUser().id;
    return {
        findLastSpecifiedActionGroup:function(type,num){
            if(angular.isUndefined(num)){
                num=1;
            }
            var url="findLastSpecifiedActionGroup.na";
            var dat={'executorId':uid,'num':num};
            if(type=='word'){
                dat.wordAccuracy='1';
            }else if(type=='paragraph'){
                dat.paraAccuracy='1';
            }else if(type=='article'){
                dat.artAccuracy='1';
            }
            return ajax.tp(url,dat,'kv');
        },
        findRecentSpecifiedActionGroup:function(type){
            // var url="findLast";
            var dat={'executorId':uid}
            if(type=='word'){
                dat.wordAccuracy='1';
            }else if(type=='paragraph'){
                dat.paraAccuracy='1';
            }else if(type=='article'){
                dat.artAccuracy='1';
            }
            dat.num=6;
            return ajax.tp(url,dat,'kv');
        },
        findActionGroup:function(datestr){
            /* 可选条件
            *   id      createTime yyyy-mm-dd
            *   executorId   wordAccuracy   paraAccuracy   senAccuracy  artAccuracy
            *   totalAccuracy  wlScore   wlActions[0] 单词id 
            *   descr   totalScore
            */
            var url="findSpecifiedActionGroup.na";
            var dat={'createTime':datestr,'executorId':uid};
            return ajax.tp(url,dat,'kv');
        },
        findSpecifiedActionGroupInPage:function(pages){
            //与上面相比，多了一个分页
            var url="findSpecifiedActionGroupInPage.na";
            console.log('findSpecifiedActionGroupInPage');
            console.log(uid);
            var dat={'executorId':uid};
            dat.size=10;
            dat.page=pages;
            return ajax.tp(url,dat,'kv');
        },
        //下面的是从大groupAction中获取ID进行小题的查询
        findArticleLearningResultDetails:function(aid){
            var url='findArticleLearningResultDetails.na';
            var dat={'id':aid};
            return ajax.tp(url,dat,'kv');
        },
        findParagraphLearningResultDetails:function(pid){
            var url='findParagraphLearningResultDetails.na';
            var dat={'id':pid};
            return ajax.tp(url,dat,'kv');
        },
        findSentenceLearningResultDetails:function(sid){
            var url='findSentenceLearningResultDetails.na';
            var dat={'id':sid};
            return ajax.tp(url,dat,'kv');
        },
        findWordLearningResultDetails:function(wid){
            var url='findWordLearningResultDetails.na';
            var dat={'id':wid};
            return ajax.tp(url,dat,'kv');
        },
        


    }
}])

myService.factory('getConditionTarget', ['ajax', function(ajax){
    return {
        getInUseReleasedArticles:function(uyear,lyear,subject,part,paragraph){
            /*
            * id    year
            * yearUpperBound
            * yearLowerBound
            * part
            * subject
            */
            var url="getInUseReleasedArticles.na";
            var dat={};
            if(!angular.isUndefined(uyear)){
                dat.yearUpperBound=parseInt(uyear)+0.1;
            }
            if(!angular.isUndefined(lyear)){
                dat.yearLowerBound=lyear;
            }
            if(!angular.isUndefined(part)){
                dat.part=part;
            }
            dat.subject=subject||'英语一';
            return ajax.tp(url,dat,'kv');
        },
        listRandomWords:function(uyear,lyear,subject,part){
            var url="listRandomWords.na";
            var dat={'num':90};
            if(!angular.isUndefined(uyear)){
                dat.yearUpperBound=parseInt(uyear)+0.1;
            }
            if(!angular.isUndefined(lyear)){
                dat.yearLowerBound=lyear;
            }
            if(!angular.isUndefined(part)){
                dat.part=part;
            }
            if(!angular.isUndefined(subject)){
                dat.subject=subject;
            }
            return ajax.tp(url,dat,'kv');
        }
    }
}])

myService.factory('getTargetRestart', ['ajax',"$state",'paragraphInfo', function(ajax,$state,paragraphInfo){
    return {
        findTargetArticle:function(ids){
            var url='findTargetArticle.na';
            var dat={'id':ids};
            return ajax.tp(url,dat,'kv')

        },
        findTargetParagraph:function(ids){
            var url='findTargetParagraph.na';
            var dat={'id':ids};
            return ajax.tp(url,dat,'kv')
        },
        findTargetWord:function(ids){
            
        },
    };
}])

myService.factory('highCharts', [function(){
    var model={
        title:{
            text:'上六次正确率变化图'
        },
        options: {
            chart: {
                type:'spline',
                backgroundColor: 'transparent',
                zoomType: 'xy',
                resetZoomButton: {
                    position: {
                        x: 0,
                        y: -35
                    },
                }
            },
            plotOptions: {
                series: {
                    lineWidth: 1,
                    fillOpacity: 0.5
                },
                column: {
                    stacking: 'normal'
                },
                area: {
                    stacking: 'normal',
                    marker: {
                        enabled: false
                    }
                }

            },
            exporting: false,
            xAxis: [{
                // min:1,
                type: '近六次成绩'
            }],
            yAxis: [
                {
                    min: 0,
                    allowDecimals: false,
                    title: {
                        text: '正确率',
                        style: {
                            color: '#80a3ca'
                        }
                    },
                    labels: {
                        format: '{value}',
                        style: {
                            color: '#80a3ca'
                        }
                    }


                }
            ],
            legend: {
                enabled: true,

            },
            title: {
                text: ' '
            },
            credits: {
                enabled: false
            },

            loading: false,
        },
        series: [
            // {
            //     name: '单词学习',
            //     // data:[35,25,33,25,53,45],
            //     yAxis: 0,
            //     color: '#24a7cb'
            // },
            // {
            //     name: '阅读学习',
            //     // data:[21,39,53,42,63,12],
            //     yAxis: 0,
            //     color: '#ee260b'
            // },
            // {
            //     // id: 'iphoneNotificationData',
            //     name: '真题学习',
            //     // data: [[1426204800000,12],[1426464000000,6],[1426550400000,10],[1426636800000,3]],
            //     // data:[44,28,43,37,74,45],
            //     yAxis: 0,
            //     color: '#93e9d7'
            // }
        ],
    }
    return {
        makeHighCharts:function(dat){  //索引0为单词，1为段落，2为真题文章
            var instance=angular.copy(model);
            angular.forEach(dat,function(va,k){
                instance.series[k].data=va;
            })
            console.log(instance.series)
            return instance;
        }

    }
}])

myService.factory('selectDataForPicker', [function(){
    var pickdata=[];
    var years=[];
    var subjects=['英语一','英语二'];
    var parts=['阅读一','阅读二','阅读三','阅读四','新题型','完形','翻译'];
    var paragraphs=['段落一', '段落二', '段落三', '段落四', '段落五', '段落六', '段落七'];
    for(var i=2006;i<=2016;i++){
        years.push(i);
    }

    var makeData=function(dat){
        var _dat=[];
        angular.forEach(dat,function(va,k){
            _dat.push({'name':va});
        });
        return _dat;
    }

    var addSubData=function(upper,sub){
        angular.forEach(upper,function(va,k){
            va.sub=sub;
        });
        return upper;
    }

    

    return {
        word:function(yearLowerBound,yearUpperBound){
            var _years,_parts;
            if(!angular.isUndefined(yearLowerBound)){
                var startPosition=years.indexOf(yearLowerBound)
                _years=years.slice(startPosition);
            }else{
                _years=years;
            }
            if(!angular.isUndefined(yearUpperBound)){
                var endPosition=_years.indexOf(yearUpperBound);
                _years=_years.slice(0,endPosition+1);
            }
            // var _years=years;
            _parts=parts;
            var yeararr=makeData(_years);
            var partarr=makeData(_parts);
            return addSubData(yeararr,partarr);
        },
        paragraph:function(yearLowerBound,yearUpperBound){
            var _years,_parts;
            if(!angular.isUndefined(yearLowerBound)){
                var startPosition=years.indexOf(yearLowerBound)
                _years=years.slice(startPosition);
            }else{
                _years=years;
            }
            if(!angular.isUndefined(yearUpperBound)){
                var endPosition=_years.indexOf(yearUpperBound);
                _years=_years.slice(0,endPosition+1);
            }
            var _parts=parts;
            var _paragraphs=paragraphs
            var yeararr=makeData(_years);
            var partarr=makeData(_parts);
            var paragrapharr=makeData(_paragraphs);
            addSubData(partarr,paragrapharr);
            return addSubData(yeararr,partarr);
        }
    };
}])


myService.filter('timeFormart',function(){
    return function(input){
        if(input<10&&input>=0){
            input='0'+input;
        }
        return input;
    }
});
/*
myService.factory('listenKey', ['$cordovaDevice', function($cordovaDevice){
    //监听andriod实体按钮事件 
         // 等待加载PhoneGap
    document.addEventListener("deviceready", onDeviceReady, false);
    // PhoneGap加载完毕
    function onDeviceReady() {
    //按钮事件
        document.addEventListener("backbutton", eventBackButton, false); //返回键
        // document.addEventListener("menubutton", eventMenuButton, false); //菜单键
        // document.addEventListener("searchbutton", eventSearchButton, false); //搜索键
    }

    //返回键
    function eventBackButton(){
    //confirm("再点击一次退出!");
        window.plugins.ToastPlugin.show_short('再点击一次退出!');
        document.removeEventListener("backbutton", eventBackButton, false); //注销返回键
        //3秒后重新注册
        var intervalID = window.setInterval(
            function() {
                window.clearInterval(intervalID);
                document.addEventListener("backbutton", eventBackButton, false); //返回键
            },
            3000
        );
    }

    return function name(){
        
    };
}])
*/