var myapp=angular.module('starter.controllers', ['starter.services'])

.controller('showSubCover', ['autoLogin','$rootScope','$scope','$timeout','$state','misc',
    function(autoLogin,$rootScope,$scope,$timeout,$state,misc){
    var d=new Date();
    var _days=['星期天','星期一','星期二','星期三','星期四','星期五','星期六'];
    // var _month=['January','February','March','April','May','June','July','August','September','October','November','December'];
    $scope.dateInfo={}
    // $scope.dateInfo.month=_month[d.getMonth()];
    $scope.dateInfo.month=1+d.getMonth();
    if ($scope.dateInfo.month<10) {
        $scope.dateInfo.month='0'+$scope.dateInfo.month;
    }
    $scope.dateInfo.month+='月';
    $scope.dateInfo.day=d.getDate();
    $scope.dateInfo.weekday=_days[d.getDay()];
    if($scope.dateInfo.day<10){
        $scope.dateInfo.day='0'+$scope.dateInfo.day;
    }
    $scope.dateInfo.day+='日';
    $scope.dateInfo.year=d.getFullYear()+'年';

    document.addEventListener("deviceready", function () {
        autoLogin();
        $timeout(function(){
            // $scope.closePopover();
            $rootScope.cover=0;
            misc.makeGPS();
        },1000);
    }, false);

    $scope.goStudyOption=function(){
        $state.go('studyOption.studyOptionContent');
    }
}])

.controller('studyOption',['$ionicPlatform','evaluateResult','$rootScope','$scope','$timeout','misc','userinfo',
    function($ionicPlatform,evaluateResult,$rootScope,$scope,$timeout,misc,userinfo){
    var user=userinfo.getUser();
    // alert(5);
    if(angular.isUndefined(user)){
        alert('没有用户信息');
    }
    $scope.viewedQuestionNum=user.viewedQuestionNum;
    $scope.totalQuestionNum=user.totalQuestionNum;
    $scope.learningProcess=misc.getLearningProcess(user.viewedQuestionNum,user.totalQuestionNum);
    // console.log($scope.learningProcess);
    
    //计算剩余还有多少天
    misc.getLeftDays()
    .success(function(res){
        // console.log("剩余日期");
        $scope.leftDays=res-1;
    })
    misc.getAccountRank(user.id)
    .success(function(res){
        // console.log(res);
        if(parseInt(res.content)>=100){
            $scope.accountRank='0%';
        }else{
            $scope.accountRank=(100-res.content*100).toString().substr(0,4)+'%';
        }
        // console.log($scope.accountRank);
    })

    if(ionic.Platform.isAndroid()){
        $scope.pfm='android';   
    }else if(ionic.Platform.isIOS()){
        $scope.pfm='ios';
    }else if(ionic.Platform.isWebView()){
        $scope.pfm='web';
    }
    // console.log($scope.pfm);

}])
.controller('contactUs', ['$scope','$rootScope','misc','$state',
    function($scope,$rootScope,misc,$state){
    $scope.returnStudyOption=function(){
        $state.go('studyOption.studyOptionContent');
    }
    $rootScope.returnStudyOption=$scope.returnStudyOption;
}])

.controller('login',['$rootScope','$ionicPlatform','$state','$timeout','$cordovaDevice','$ionicPopover','$cordovaDialogs','$scope','ajax','$window','autoLogin','userinfo','$ionicPopup','$http','misc',
    function($rootScope,$ionicPlatform,$state,$timeout,$cordovaDevice,$ionicPopover,$cordovaDialogs,$scope,ajax,$window,autoLogin,userinfo,$ionicPopup,$http,misc) {

    $scope.senddata={};
    $scope.sendMail={};
    $scope.user={};
    $scope.accountLogin=false;
    // console.log($scope.user);
    document.addEventListener("deviceready", function () {
        // console.log('login调试');
        
        $timeout(function(){
            // $scope.closePopover();
            $rootScope.cover=0;
        },1000);
        // console.warn($cordovaDevice);
        // console.log('deviceready,准备autoLogin');

        autoLogin();
        // var uuid = $cordovaDevice.getUUID();
        // if(uuid){
        //     $window.localStorage['deviceCode']=uuid;
        // }
    }, false);
    //自动登陆结束后要进行判断
    
    $scope.$on('userinfoChanged',function(event,data){
        // console.log('user改变了');
        $scope.user=data;
        // console.log($scope.user);
        if($scope.user&&$scope.user.accountName){
            // console.log('进入到这里了');
            $scope.accountLogin=true;
            var _emails=misc.devideEmail($scope.user.profile.mails);
            angular.forEach(_emails,function(va,k){
                $scope.sendMail[k]=va;
            });
            _emails=undefined;
        }
    });

    $scope.logout=function(){
        // console.log('退出登录');
        $scope.user='';
        $scope.sendMail={};
        $window.localStorage['account']='';
        $window.localStorage['password']='';
        $window.localStorage['userInfo']='';
        $scope.accountLogin=false;
    }
    
    $scope.goForgetPassword=function(){
        $state.go('forgetPassword');
    }


    $scope.toLogin=function(){
        
        var _dat={
            'accountName':$scope.senddata.account,
            'password':$scope.senddata.password
        }
        var url="loginWithPassword.na";
        
        ajax.tp(url,_dat,'kv')
        .success(function(res){
            if(res.success==true){
                $window.localStorage['account']=res.content.accountName;
                $window.localStorage['password']=_dat.password;
                userinfo.saveUser(res.content);
                $scope.user=userinfo.getUser();
                $scope.accountLogin=true;
                var _emails=misc.devideEmail($scope.user.profile.mails);
                angular.forEach(_emails,function(va,k){
                    $scope.sendMail[k]=va;
                });
            }else{
                // console.log(res);
                $scope.accountLogin=false;
                $ionicPopup.alert({
                    title:'自学君提示您',
                    template:"<span class='zhf_bianda'>"+res.info+"</span>",
                    buttons:[{
                        text:'朕知道了',
                        type:'button-xdf',
                    }]
                });
            }
            // console.log($scope.user);
        });

    }

    $scope.bindDevice=function(){
        // if($scope.)
        var url="bindAccountToDevice.na";
        var _dat={};
        var deviceCode=$window.localStorage['deviceCode'];
        var password=$window.localStorage['password'];
        var account=$window.localStorage['account'];
        _dat={
            'deviceCode':deviceCode,
            'password':password,
            'accountName':account
        }
        // console.log(_dat);
        ajax.tp(url,_dat,'kv')
        success(function(res){
            if(res.success==true){
                $ionicPopup.alert('恭喜您绑定成功');
                userinfo.saveUser(res.content);
                $scope.user=userinfo.getUser();
            }else{
                $ionicPopup.alert(res.info);
            }
        });
    }
    $scope.returnStudyOption=function(){
        $state.go('studyOption.studyOptionContent');
    }
    $rootScope.returnUpper=$scope.returnStudyOption;


    $scope.proSendEmail=function(mails){
        var url="updateProfile.na";
        var dat={'id':$scope.user.profile.id,'mails':mails};
        ajax.tp(url,dat,'kv')
        .success(function(res){
            autoLogin();
            $ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda'>处理成功。</span>",
                buttons:[{
                    text:'朕知道了',
                    type:'button-xdf',
                }]
            })
        })
        .error(function(){
            $ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda'>发生了错误！</span>",
                buttons:[{
                    text:'朕知道了',
                    type:'button-xdf',
                }]
            })
        })
    }

    $scope.changeSendEmail=function(){
        $scope.sendMail={};
        $scope.proSendEmail('');
    }
    
    $scope.submitSendEmail=function(){
        var mails=$scope.sendMail[0]+','+$scope.sendMail[1];
        $scope.proSendEmail(mails);
    }
}])

.controller('user', ['autoLogin','$scope','$rootScope','$state','userinfo','$ionicPopup','ajax',
    function(autoLogin,$scope,$rootScope,$state,userinfo,$ionicPopup,ajax){
    var user=userinfo.getUser();
    if(user.accountName=='lizheng'){
        $scope.admin=true;
    }
    $scope.passwordGroup={};

    $scope.goNgtest=function(){
        $state.go('ngTest');
    }


    $scope.returnLogin=function(){
        $state.go('studyOption.login');
    }
    $scope.goAboutUs=function(){
        $state.go('aboutUs');
    }
    $scope.goFaq=function(){
        $state.go('faq');
    }
    $scope.changePassword=function(){
        var _t=$ionicPopup.show({
            title:'修改密码',
            templateUrl:'templates/changePassword.html',
            scope:$scope,
            buttons:[{
                text:'确定',
                type:'button,button-xdf',
                onTap:function(){
                    // var nowPassword=userinfo.getLoignPassword();
                    // console.log($scope.passwordGroup.oldPassword);
                    if($scope.passwordGroup.newPassword==$scope.passwordGroup.newPasswordAgain){
                        var url="modifyPassword.na";
                        var dat={'id':user.id,'password':$scope.passwordGroup.oldPassword,'newPassword':$scope.passwordGroup.newPassword}
                        ajax.tp(url,dat,'kv')
                        .success(function(res){
                            // console.log(res);
                            if(res.success==true){
                                userinfo.saveAP(user.accountName,$scope.passwordGroup.newPassword);
                                autoLogin();
                            }
                            $ionicPopup.alert({
                                title:'自学君提示您',
                                template:"<span class='zhf_bianda'>"+res.info+"</span>",
                                buttons:[
                                {
                                    text:'朕知道了',
                                    type:'button-xdf,button'
                                }]
                            })
                        })
                    }else{
                        return {'success':false,'content':'您两次输入的密码不一致。'};
                    }
                }
            },{
                text:'取消',
                type:'button,button-xdf',
            }]
        });
        _t.then(function(e){
            if(!angular.isUndefined(e)){
                $ionicPopup.alert({
                    title:'自学君提示您',
                    template:"<span class='zhf_bianda'>"+e.content+"</span>",
                    buttons:[
                    {
                        text:'朕知道了',
                        type:'button-xdf,button'
                    }]
                })
            }else{

            }

        })
    }
    $rootScope.returnUpper=$scope.returnLogin;
}])

.controller('aboutUs', ['$scope','$rootScope','$state',
    function($scope,$rootScope,$state){
    $scope.returnUser=function(){
        $state.go('user');
    }
    $rootScope.returnUpper=$scope.returnUser;
    
}])
.controller('faq', ['$scope','$rootScope','$state',
    function($scope,$rootScope,$state){
    $scope.returnUser=function(){
        $state.go('user');
    }
    $rootScope.returnUpper=$scope.returnUser;
}])
//注册页面控制器
.controller('loginRegister',['$rootScope','ajax','$scope','$ionicPopup','userinfo','$state','$window', 
    function($rootScope,ajax,$scope,$ionicPopup,userinfo,$state,$window) {
    $scope.senddata={};
    $scope.toAccountRegister=function(){
        var deviceCode=$window.localStorage['deviceCode'];
        var _dat={'accountName':$scope.senddata.username,'password':$scope.senddata.password,'deviceCode':deviceCode};
        var url="registerWithPassword.na";
        var __str=$scope.senddata.username;
        if(angular.isUndefined($scope.senddata.username)){
            $ionicPopup.alert({
                'title':'自学君提示您',
                'template':"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>您必须输入EMAIL作为账号</span>",
                'buttons':[{
                    'text':'朕知道了',
                    'type':'button-xdf',
                }]
            });
            return false;
        }

        if($scope.senddata.password==''||angular.isUndefined($scope.senddata.password)){
            $ionicPopup.alert({
                'title':'自学君提示您',
                'template':"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>密码不能为空。</span>",
                'buttons':[{
                    'text':'朕知道了',
                    'type':'button-xdf',
                }]
            });
            return false;
        }

        if($scope.senddata.password!=$scope.senddata.repassword){
            $ionicPopup.alert({
                'title':'自学君提示您',
                'template':"<span style=' color:#585858; line-height:24px; padding-top:-10px;'>您两次输入的密码不一致。</span>",
                'buttons':[{
                    'text':'朕知道了',
                    'type':'button-xdf',
                }]
            });
            return false;
        }
        // console.log(_dat);
        ajax.tp(url,_dat,'kv')
        .success(function(res){
            // console.log('正式账号注册信息');
            if(res.success==true){
                //注册成功
                var _url="loginWithPassword.na";
                ajax.tp(_url,_dat,'kv')
                .success(function(res){
                    if(res.success==true){
                        userinfo.saveUser(res.content);
                        $scope.user=userinfo.getUser();
                        userinfo.saveAP(_dat.accountName,_dat.password);

                        $scope.accountLogin=true;
                        $state.go('studyOption.login');
                    }
                });
            }else{
                //注册失败 
                $ionicPopup.alert({
                    title:res.info,
                    template:"<span class='zhf_bianda'>"+res.info+"</span>",
                    buttons:[{
                        text:'朕知道了',
                        type:'button-xdf',
                    }]
                });
            }
        });
    }
    $scope.returnStudyOption=function(){
        $state.go('studyOption.studyOptionContent');
    }

    $rootScope.returnUpper=$scope.returnStudyOption;
    // $ionicPlatform.onHardwareBackButton(function(e){
    //     $scope.returnStudyOption();
    //     e.preventDefault();
    // });

}])

.controller('forgetPassword', ['$rootScope','$scope','ajax','$ionicPopup','$state', function($rootScope,$scope,ajax,$ionicPopup,$state){

    $scope.user={};

    $scope.returnLogin=function(){
        $state.go('studyOption.login');
    }

    $scope.getForgetPasswordUrl=function(){
        if(angular.isUndefined($scope.user.account)){
            $ionicPopup.alert({
                'title':'',
                'template':"<span class='zhf_bianda'>您输入的邮箱格式不正确，请检查后重新输入。</span>",
                'buttons':[{
                    'text':'朕知道了',
                    'type':'button-xdf',
                }]
            });
            return false;
        }else{
            var url="startNewPasswordResetRequest.na";
            var dat={'mail':$scope.user.account};
            ajax.tp(url,dat,'kv')
            .success(function(res){
                $ionicPopup.alert({
                    'title':'',
                    'template':"<span class='zhf_bianda'>"+res.info+"</span>",
                    'buttons':[{
                        'text':'朕知道了',
                        'type':'button-xdf'
                    }]
                });
            })
        }
    }


    $rootScope.returnUpper=$scope.returnLogin;
}])
;


//自我测评
myapp.controller('myEvaluate',['questionsResult','learning','evaluateResult','$rootScope','$ionicPlatform','$ionicSlideBoxDelegate','evaluateInfo','userinfo','ajax','selfEvaluate','$scope','$state','$ionicPopup','shuffle',
    function(questionsResult,learning,evaluateResult,$rootScope,$ionicPlatform,$ionicSlideBoxDelegate,evaluateInfo,userinfo,ajax,selfEvaluate,$scope,$state,$ionicPopup,shuffle){
    //随机一份考试卷
    var user=userinfo.getUser();
    var loc='';
    $scope.sub={};
    $scope.resultArr=[];
    $scope.show={};
    $scope.optionStatus={};
    $scope.init=function(){
        // console.log('初始化 myEvaluate');
        selfEvaluate.listRandomSelfExams()
        .success(function(res){
            // console.log(res);
            if(res.length){
                selfEvaluate.startSelfExamination(res[0].id,user.id,loc)
                .success(function(ress){
                    // console.log(res);
                    evaluateInfo.saveEvaluateLearning(ress);
                    $scope.learning=evaluateInfo.getEvaluateLearning();
                    // $scope.eva=res[0];
                    $scope.reBuildEva(res[0]);
                    // console.log($scope.eva);
                    evaluateResult.prepareEva($scope.eva,'eva');

                    questionsResult.saveBody($scope.eva);
                });
            }
        });
    }
    $scope.init();

    //测试 调用历史做题记录
    // evaluateResult.findActionGroup('2016-06-29',user.id)
    // .success(function(res){
    //     console.log(res);
    // });

    $scope.returnStudyOption=function(){
        var action=evaluateInfo.getEvaluateLearning();
        // console.log(action);
        if(action){
            selfEvaluate.updateSelfEvaluateDuration(action.content.id);
        }
        $state.go('studyOption.studyOptionContent');
    }

    $rootScope.endMyEvaluate=$scope.returnStudyOption;

    $scope.reBuildEva=function(eva){
        $scope.eva=[];
        // console.log(eva);
        // console.log(eva.wordGroups[0]);
        // console.log(eva.wordGroups[0].words);
        // if(eva.wordGroups[0].length){
            angular.forEach(eva.wordGroups[0].words,function(va,k){

                // console.log('wq');
                // console.log(va);
                va.questions[0].options=shuffle(va.questions[0].options);
                if(va.questions.length){
                    va.questions[0].myType='word';
                    va.questions[0].mainContent=va.spell;
                    angular.forEach(va.options,function(sv,sk){
                        $scope.optionStatus[sv.id]=false;
                    });
                    $scope.eva.push(va.questions[0]);
                }
            });
        // }
        angular.forEach(eva.paraGroups[0].paras,function(va,k){
            // va.questions=va.simulatedQuestions;
            // va.simulatedQuestions=undefined;
            var thisPara=[];
            var thisSentenceAnalysis=[];
            // console.log("rebuild");
            angular.forEach(va.sentences,function(sva,svk){
                thisPara.push(sva.text);
                thisSentenceAnalysis.push(sva.preciseTranslation);
            });
            // console.log(va);
            if(va.simulatedQuestions.length){
                angular.forEach(va.simulatedQuestions,function(vaa,kk){
                    vaa.options=shuffle(vaa.options);
                    vaa.myType='para';
                    vaa.mainContent=thisPara;
                    vaa.sentenceAnalysis=thisSentenceAnalysis;
                    angular.forEach(va.options,function(sv,sk){
                        $scope.show[sv,id]=false;
                        $scope.optionStatus[sv.id]=false;
                    });
                    $scope.eva.push(vaa);
                });
            }
        });
        $scope.currentQuestion=0;
        $scope.maxQuestion=$scope.eva.length;
        if($scope.currentQuestion!=$scope.maxQuestion){
            $scope.showNext=1;
        }
    }

    $scope.toNext=function(){
        $scope.currentQuestion++;
        $scope.pendingPage($scope.currentQuestion);
        $ionicSlideBoxDelegate.next();
    }
    $scope.toPrevious=function(){
        $scope.currentQuestion--;
        $scope.pendingPage($scope.currentQuestion);
        $ionicSlideBoxDelegate.previous();
    }
    $scope.pendingPage=function(current){
        if(current!=$scope.maxQuestion-1){
            $scope.showNext=1;
            $scope.showResult=0;
        }else if(current==$scope.maxQuestion-1){
            $scope.showNext=0;
            $scope.showResult=1;
        }
    }

    $scope.slideChanged = function(index) {
        $scope.currentQuestion = index;
        $scope.pendingPage($scope.currentQuestion);
    };
    //自我测评中 增加选项的排除功能
    $scope.giveup=function(opid){
        var action=evaluateInfo.getEvaluateLearning();
        var qid=$scope.eva[$scope.currentQuestion].id;
        if($scope.eva[$scope.currentQuestion].myType=='para'){
            var _type='paragraph';
        }else{
            var _type='word';
        }
            if(!$scope.optionStatus[opid]){
                selfEvaluate.addSelfExaminationSingleAnswerQuestionOptionOperation(action.content.id,qid,opid,'','',_type)
                $scope.optionStatus[opid]=true;
            }else{
                selfEvaluate.addSelfExaminationSingleAnswerQuestionOptionOperation(action.content.id,qid,opid,'取消排除','',_type)
                $scope.optionStatus[opid]=false;
            }


    }

    $scope.giveGeneralMeaning=function(k){
        $ionicPopup.alert({
            title:'君，中文是酱紫的',
            template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>"+$scope.eva[$scope.currentQuestion].sentenceAnalysis[k]+"</span>",
            buttons:[{
                text:'朕知道了',
                type:'button-xdf',
            }]
        });
    }

    $scope.directSubmit=function(e){
        e.stopPropagation();
        $scope.myEvaluateSubmit();
    }

    $scope.myEvaluateSubmit=function(type){
        var index=$ionicSlideBoxDelegate.currentIndex();
        var isCorrect=false;
        var questionId='';
        var thisQuestion=$scope.eva[index];
        questionId=thisQuestion.id;
        var optionid=thisQuestion.options[$scope.sub[questionId]].id;
        // console.log(optionid);
        angular.forEach(thisQuestion.options,function(va,k){
            if(va.id==optionid){
                isCorrect=va.isCorrect;
            }
        });
        var action=evaluateInfo.getEvaluateLearning();
        // console.log(questionId);
        // console.log(type);
        selfEvaluate.addSelfEvaluateQuestionAnswer(thisQuestion.myType,questionId,optionid,isCorrect,action.content.id,'')
        .success(function(res){
            var alertPopup=$ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda'>提交答案成功</span>",
                buttons:[{
                    'text':'朕知道了',
                    'type':'button-xdf',
                }]
            });
            alertPopup.then(function(res) {

                var _obj={};
                _obj.myType=thisQuestion.myType||'word';
                _obj.id=questionId;
                _obj.isCorrect=isCorrect;
                _obj.opid=optionid;
                _obj.questionType=thisQuestion.questionType;
                evaluateResult.saveResult(_obj);
                _obj=undefined;

                if($scope.showNext){
                    $scope.toNext();
                }
                //可能会直接显示报告;
                // if($scope.showResult){
                //      $scope.goShowResult();
                // }
            });
        });
    }

    $scope.goShowResult=function(){
        $state.go('showResult',{'from':'eva'});
    }

}]);


//文章列表页控制器
myapp.controller('article',['misc','questionsResult','$rootScope','$ionicPlatform','articleInfo','active','$ionicSlideBoxDelegate','$ionicHistory','$stateParams','$scope','learning','ajax','$ionicListDelegate','countTimer','$state','userinfo','$ionicModal','$ionicGesture','$timeout','shuffle','$ionicPopup','evaluateResult',
    function(misc,questionsResult,$rootScope,$ionicPlatform,articleInfo,active,$ionicSlideBoxDelegate,$ionicHistory,$stateParams,$scope,learning,ajax,$ionicListDelegate,countTimer,$state,userinfo,$ionicModal,$ionicGesture,$timeout,shuffle,$ionicPopup,evaluateResult){
    // var user=userinfo.getUser();
    var user=active.user;
    var articleStatus=articleInfo.getArticleStatus();
    $scope.senddata={};
    $scope.sub={};
    $scope.question={};
    $scope.optionStatus={};
    $scope.show={};




    $scope.aid=$stateParams.aid;

    learning.getReleasedArticle($scope.aid)
    .success(function(res){
        // console.log(res);
        $scope.article=res;
        questionsResult.saveBody($scope.article);

        angular.forEach(res.pastQuestions,function(va,k){

            res.pastQuestions[k].options=shuffle(va.options);

            angular.forEach(va.options,function(sv,sk){
                $scope.optionStatus[sv.id]=false;
                $scope.show[sv.id]=false;
            });
        });

        $timeout(function(){
            $scope.questionStatus=true;
        },10);
        if(res.pastQuestions.length){
            $scope.question.status=false;
            $scope.currentQuestion=0;
            $scope.maxQuestion=res.pastQuestions.length;
        }
        if($scope.currentQuestion!=$scope.maxQuestion){
            $scope.showNext=1;
        }

        if(articleStatus==0||angular.isUndefined(articleStatus)){
            countTimer.clearTimer();
            var gps=misc.getGPS();
            learning.startArticleLearning(res.id,user.id,gps)
            .success(function(ress){
                articleInfo.saveArticleAction(ress);
                var action=articleInfo.getArticleAction();
                // console.log(action);
                articleInfo.saveArticleStatus(1);
                // console.log('为真题添加actionid');
                // console.log(res.pastQuestions);
                angular.forEach(res.pastQuestions,function(vva,ssk){
                    // console.log(action);
                    res.pastQuestions[ssk].actionid=action.content.id;
                    // vva.actionid=action.content.id;
                });
                evaluateResult.prepareEva(res.pastQuestions,'article');
            })
        }

        //初始化article 真题的测评eva
        // countTimer.startTimer();
    })
    
    $scope.directSubmit=function(e){
        e.stopPropagation();
        $scope.toSubmit();
    }

    // $scope.pastQuestionSubmit=function(currentIndex){
    $scope.toSubmit=function(currentIndex){

        var index=$ionicSlideBoxDelegate.currentIndex();
        var isCorrect=false;
        var questionId='';
        var thisQuestion=$scope.article.pastQuestions[index];
        thisQuestion.myType='article';
        questionId=thisQuestion.id;
        // var optionid=$scope.rememberWord[questionId];
        if(angular.isUndefined($scope.sub[questionId])){
            $ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda'>您还没有选择答案</span>",
                buttons:[{
                    text:'朕知道了',
                    type:'button-xdf',
                }]
            });
            return false;

        }
        var optionid=thisQuestion.options[$scope.sub[questionId]].id;
        angular.forEach(thisQuestion.options,function(va,k){
            if(va.id==optionid){
                isCorrect=va.isCorrect;
            }
        });
        // var num=_qv[index];
        var action=articleInfo.getArticleAction();
        // console.log(questionId);
        // console.log(isCorrect);
        learning.addArticleLearningPastSingleAnswerQuestionAnswer(questionId,optionid,isCorrect,action.content.id,'')
        .success(function(res){
            // console.log('更新了真题答案');
            // console.log('res');
            var alertPopup=$ionicPopup.alert({
                title:'自学君提示您',
                template:'<p style="text-align:center" class="zhf_bianda">提交答案成功</p>',
                buttons:[{
                    text:'朕知道了',
                    type:'button-xdf',
                }]
            })
            alertPopup.then(function(res) {
                var _obj={};
                _obj.myType=thisQuestion.myType||'article';
                _obj.id=questionId;
                _obj.opid=optionid;
                _obj.actionid=action.content.id;
                _obj.isCorrect=isCorrect;
                _obj.questionType=thisQuestion.questionType;
                evaluateResult.saveResult(_obj);
                _obj=undefined;

                if($scope.showNext){
                    $scope.toNext();
                }
                //可能会直接显示报告;以后再根据实际情况定吧
                // if($scope.showResult){
                //      $scope.goShowResult();
                // }
            });
        });
    }

    $scope.giveup=function(opid){
        // console.log(active.action.id);
        var action=articleInfo.getArticleAction();
        if(!$scope.optionStatus[opid]){
            learning.addArticleLearningPastSingleAnswerQuestionOptionOperation(action.content.id,$scope.article.pastQuestions[$scope.currentQuestion].id,opid,'','')
            $scope.optionStatus[opid]=true;
        }else{
            learning.addArticleLearningPastSingleAnswerQuestionOptionOperation(action.content.id,$scope.article.pastQuestions[$scope.currentQuestion].id,opid,'取消排除','')
            $scope.optionStatus[opid]=false;
        }
    }
    $scope.recordAnalysis=function(opid){
        if($scope.show[opid]==true){
            var action=articleInfo.getArticleAction();
            learning.addArticleLearningPastSingleAnswerQuestionOptionOperation(action.content.id,$scope.article.pastQuestions[$scope.currentQuestion].id,opid,'查看解析','');
        }
    }

    $scope.goShowResult=function(){
        $state.go('showResult',{'from':'article'});
    }

    $scope.returnArticleList=function(){
        $ionicPopup.confirm({
            'title':'自学君提示您',
            'template':"<span class='zhf_bianda'>您确定要退出吗？这将会丢失当前的学习记录。</span>",
            'cancelText':'取消',
            'cancelType':'button-lighter',
            'okText':'确定',
            'okType':'button-yuanjiao',
        }).then(function(r){
            if(r){
                articleInfo.saveArticleStatus(0);
                var action=articleInfo.getArticleAction();
                var timer= Date.parse(new Date())/1000;
                learning.updateArticleLearningDuration(timer,action.content.id);
                $state.go('articleList');
            }
        });
    }

    $scope.raiseErrorMessage=function(){
        $scope.errorMessage={};
        // console.log('提交一个错误，raiseErrorMessage');
        var dat={};
        dat.year=$scope.errorMessage.year=$scope.article.year;
        dat.part=$scope.errorMessage.part=$scope.article.part;
        dat.subject=$scope.errorMessage.subject=$scope.article.subject;
        dat.descr=misc.getNowTime();
        var t=$ionicPopup.show({
            title:'我要提交一个建议',
            templateUrl:'templates/raiseErrorMessage.html',
            scope:$scope,
            buttons:[{
                text:'确认',
                type:'button,button-xdf',
                onTap:function(e){
                    return $scope.errorMessage.errorDescr;
                }
            },{
                text:'取消',
                type:'button,button-xdf',
                
            }]
        });
        t.then(function(r){
            if(!angular.isUndefined(r)){
                dat.errorDescr=r;
                misc.raiseErrorMessage(dat);
            }
        })

    }

    $rootScope.returnArticleList=$scope.returnArticleList;
    // $ionicPlatform.onHardwareBackButton(function(e){
    //     $scope.returnArticleList();
    //     e.preventDefault();
    // });
    $scope.toNext=function(){
        $scope.currentQuestion++;
        $scope.pendingPage($scope.currentQuestion);
        $ionicSlideBoxDelegate.next();
        // console.log($scope.question);
    }
    $scope.toPrevious=function(){
        $scope.currentQuestion--;
        $scope.pendingPage($scope.currentQuestion);
        $ionicSlideBoxDelegate.previous();
        // console.log($scope.question);
    }
    $scope.pendingPage=function(current){
        if(current!=$scope.maxQuestion-1){
            $scope.showNext=1;
            $scope.showResult=0;
        }else if(current==$scope.maxQuestion-1){
            $scope.showNext=0;
            $scope.showResult=1;
        }
    }

    $scope.slideChanged = function(index) {
        $scope.currentQuestion = index;
        $scope.pendingPage($scope.currentQuestion);
    };

    $ionicModal.fromTemplateUrl('my-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });
    $scope.openModal = function() {
        $scope.modal.show();
    };
    $scope.closeModal = function() {
        $scope.modal.hide();
    };
    $scope.onDragUp=function(){
        // console.log(111);
    }
    $scope.giveGeneralMeaning=function(k,sk){
        $ionicPopup.alert({
            title:'君，中文是酱紫的',
            template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>"+$scope.article.paragraphs[k].sentences[sk].preciseTranslation+"</span>",
            buttons:[{
                text:'朕知道了',
                type:'button-xdf',
            }]
        });
    }
}]);


myapp.directive('articleView', ['$ionicGesture','$ionicScrollDelegate', 
    function($ionicGesture,$ionicScrollDelegate){
    return {
        restrict: 'A', // E = Element, A = Attribute, C = Class, M = Comment
        link: function(scope, element, attrs, controller) {
            var kj=angular.element(document.getElementById('kj'));
            var uc=angular.element(document.getElementById('uc'));
            var dc=angular.element(document.getElementById('dc'));
            // var dcDelegate=$ionicScrollDelegate.$getByHandle('dc');
            $ionicScrollDelegate.$getByHandle('dcDelegate').scrollBottom();
            $ionicScrollDelegate.$getByHandle('ucDelegate').scrollBottom();

            var ch=element[0].offsetHeight;
            // console.log(ch);
            scope.uc={};
            scope.dc={};
            // var releaseFun=function(e){
            //         console.log(e);
            //         // alert('on');
            //         scope.end=e.gesture.deltaY;
            //         console.log('德尔塔Y');
            //         console.log(e.gesture.deltaY);
            //         var _a=parseInt($scope.start)+parseInt($scope.end);
            //         console.log(_a);
            //         kj.css({
            //             'top':_a+'px',
            //             'position':'absolute',
            //             'z-index':1001,
            //             // 'padding':'0px'
            //         });
            //         // e.target.offsetTop='15px';
            //         $scope.$apply();

            //     }
            var _du=''; //上面content回掉函数
            var _dd=''; //下面content回掉函数

            var _duFn=function(e){
                //margin-top 用于 dc    height用于uc
                uc.css({
                    'height':(scope.uc.height+e.gesture.deltaY)+'px'
                });
                dc.css({
                    'margin-top':(scope.dc.marginTop+e.gesture.deltaY)+'px'
                });
                // ionic.offGesture(_t,'release',releaseFun);
            }

            var _ddFn=function(e){
                uc.css({
                    'height':(scope.uc.height+e.gesture.deltaY)+'px'
                });
                dc.css({
                    'margin-top':(scope.dc.marginTop+e.gesture.deltaY)+'px'
                });
                // ionic.offGesture(_t,'release',releaseFun);
            }



            $ionicGesture.on('hold',function(e){
                // dc[0].attr({overflowScroll:false});
                // console.log(dcDelegate);
                var _height=uc[0].style.height;
                var _marginTop=dc[0].style.marginTop;
                if(_height.indexOf('%')!=-1){
                    // console.log('找到百分号');
                    scope.uc.height=ch*parseInt(_height)/100;
                }else if(_height.indexOf('px')!=-1){
                    // console.log('找到像素符号');
                    scope.uc.height=parseInt(_height);
                }
                if(_marginTop.indexOf('%')!=-1){
                    // console.log('找到百分号');
                    scope.dc.marginTop=ch-[ch*parseInt(_marginTop)/100];
                }else if(_marginTop.indexOf('px')!=-1){
                    // console.log('找到像素符号');
                    scope.dc.marginTop=parseInt(_marginTop);
                }
                // scope.uc.height=ch*parseInt(uc[0].style.height)/100;
                // scope.dc.marginTop=ch*parseInt(dc[0].style.marginTop)/100;
                // console.log(uc[0].style.height);
                // console.log(dc[0].style.marginTop);
                // console.log(scope.dc.marginTop);
                // console.log(scope.uc.height);
                scope.start=e.target.offsetTop;
                // scope.ofWidth=e.target.offsetParent.clientWidth;
                // scope.ofHeight=e.target.offsetParent.clientHeight;

                // console.log(scope.ofHeight);
                _du=$ionicGesture.on('dragup',_duFn,kj);
                _dd=$ionicGesture.on('dragdown',_ddFn,kj);
            },kj);

            $ionicGesture.on('release',function(e){
                ionic.offGesture(_dd,'dragdown',_ddFn);
                ionic.offGesture(_du,'dragup',_duFn);

            },kj);
        }
    };
}]);

myapp.directive('articleListDirective', ['misc','$compile', function(misc,$compile){
    // Runs during compile
    return {
        // name: '',
        // priority: 1,
        // terminal: true,
        // scope: {}, // {} = isolate, true = child, false/undefined = no change
        // controller: function($scope, $element, $attrs, $transclude) {},
        // require: 'ngModel', // Array = multiple requires, ? = optional, ^ = check parent elements
        restrict: 'A', // E = Element, A = Attribute, C = Class, M = Comment
        // template: '',
        // templateUrl: '',
        // replace: true,
        // transclude: true,
        // compile: function(tElement, tAttrs, function transclude(function(scope, cloneLinkingFn){ return function linking(scope, elm, attrs){}})),
        link: function($scope, element, attrs, controller) {
            k=attrs.articleListDirective;
            // console.log(k);
            element.html($scope.articleList[k].articleDifficultyDegree);
            $compile(element.contents())($scope);
        }
    };
}]);
myapp.controller('articleList', ['misc','$rootScope','$ionicPlatform','$ionicScrollDelegate','$ionicListDelegate','$scope','ajax','learning','$state',
    function(misc,$rootScope,$ionicPlatform,$ionicScrollDelegate,$ionicListDelegate,$scope,ajax,learning,$state){
    $scope.listEnd=false;
    $scope.currentPage=0;
    $scope.articleList=[];

    $scope.$on('scroll.infiniteScrollComplete',function(event,data){
        // console.log(data);
        $scope.listEnd=data;
    });

    learning.getReleasedArticleList(0)
    .success(function(res){
        // if(res.last==true){
        //     console.log('listEnd true');
        //     $scope.listEnd==true;
        // }
        // console.log(res);
        $scope.articleList=res.content;
        angular.forEach($scope.articleList,function(va,k){
            va.articleDifficultyDegree=misc.giveStar(va.articleDifficultyDegree,{'class':'energized'});
        });
        // console.log($scope.articleList);
        $scope.currentPage=res.number;
        $scope.$broadcast('scroll.infiniteScrollComplete',res.last);

    });
    

    
    $scope.loadMore = function() {
        // alert('more');
        if($scope.listEnd==true){
            // console.log('最后一页')
            return false;
        }
        learning.getReleasedArticleList($scope.currentPage+1)
        .success(function(res) {
            //这里需要有个页面判断是不是读的最后一页  有的话就将$scope.listEnd true
            if(res.last==true){
                $scope.listEnd==true;
            }
            $scope.currentPage=res.number;
            for(var i=0;i<res.content.length;i++){
                res.content[i].articleDifficultyDegree=misc.giveStar(res.content[i].articleDifficultyDegree,{'class':'energized'});

                $scope.articleList.push(res.content[i]);    
            }
            $scope.$broadcast('scroll.infiniteScrollComplete',res.last);
        });
    };

    $scope.$on('$stateChangeSuccess', function() {
        // $scope.loadMore();
    });

    $scope.goArticle=function(aid){
        $state.go('article',{'aid':aid});
    }

    $scope.goContact=function(){
        $state.go('studyOption.contactUs');
    }

    $scope.returnStudyOption=function(){
        $state.go('studyOption.studyOptionContent');
    }

    $rootScope.returnUpper=$scope.returnStudyOption;
    // $ionicPlatform.onHardwareBackButton(function(e){
    //     $scope.returnStudyOption();
    //     e.preventDefault();
    // });
}]);

// myapp.directive('pdomFinish',['$timeout','paragraphInfo','$rootScope',
//     function($timeout,paragraphInfo,$rootScope){
//     return {
//         restrict:'A',
//         link:function(scope,element,attrs){
//             console.log('pdomFinish');
//             // alert('pdomFinish1');
//             // element.on('load',function(){
//             //     alert('load');

//             // });
//             // scope.addEventListener
//             // $timeout(waveandwave.startWatch(),100);
           
//         }
//    }
// }]);


myapp.directive('paragraphWaveDirective',['$compile','misc','learning','paragraphInfo',
    function($compile,misc,learning,paragraphInfo){
    return {
        restrict:'A',
        link:function(scope,element,attrs){
            scope.wave=function(){
                var _ajax=learning.listRandomParagraphs();
                _ajax.success(function(res){
                    paragraphInfo.saveParagraph(res[0]);
                    paragraphInfo.saveParagraphStatus(0);
                    // console.log('显示摇一摇段落');
                    res[0].difficultyDegree=misc.giveStar(res[0].difficultyDegree,{'class':'energized'});
                    element.html(res[0].difficultyDegree);
                    $compile(element.contents())(scope);
                    // console.log(res[0]);
                    scope.para=res[0];
                    scope.startLearningParagraph(scope.para.id)
                });
            }
        }
    }
}])

//段落摇一摇页面控制器
myapp.controller('paragraphWave', ['selectDataForPicker','getConditionTarget','$compile','misc','$rootScope','$ionicPlatform','$timeout','$cordovaDialogs','$scope','ajax','learning','paragraphInfo','userinfo','$state','$window','$stateParams','$ionicPopup',
    function(selectDataForPicker,getConditionTarget,$compile,misc,$rootScope,$ionicPlatform,$timeout,$cordovaDialogs,$scope,ajax,learning,paragraphInfo,userinfo,$state,$window,$stateParams,$ionicPopup){
    var user=userinfo.getUser();
    // console.log($stateParams.phase);
    $rootScope.$on('paragraphChanged',function(event,data){
        $scope.para=paragraphInfo.getParagraph();
    });

    // $scope.wave=function(){
    //     var _ajax=learning.listRandomParagraphs();
    //     _ajax.success(function(res){
    //         paragraphInfo.saveParagraph(res[0]);
    //         paragraphInfo.saveParagraphStatus(0);
    //         console.log('显示摇一摇段落');
    //         res[0].difficultyDegree=misc.giveStar(res[0].difficultyDegree);
    //         $compile(res[0].difficultyDegree)($scope);
    //         console.log(res[0]);
    //         $scope.para=res[0];
    //     });
    // }

    $scope.startLearningParagraph=function(pid){
        // waveandwave.stopWatch();
        var gps=misc.getGPS();
        learning.startParagraphLearning(pid,gps,user.id,'paragraph')
        $scope.para='';
    }
    $scope.returnStudyOption=function(){
        // waveandwave.stopWatch();
        $state.go('studyOption.studyOptionContent');
    }
    $scope.goPattrnSetting=function(){
        $state.go('studyOption.pattrnSetting');
    }
    $scope.goContact=function(){
        $state.go('studyOption.contactUs');
    }
    $scope.goLogin=function(){
        $state.go('studyOption.login');
    }

    $rootScope.returnStudyOption=$scope.returnStudyOption;
    

    $scope.initSelect=function(){

        var vm=$scope.vm={};
        
        vm.cb = function () {
            // console.log(vm.CityPickData2.areaData)
        }
       
        vm.CityPickData2 = {
            areaData: ['请选择城市'],
            title: '请选择学习的年份',
            defaultAreaData: ['2015','阅读一','段落一'], //这里可以从其他地方传值过来作为默认值
            buttonText:"确定",
            areaService:selectDataForPicker.paragraph(),
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                // console.log('点击完成');
                // console.log(vm.CityPickData2.areaData);
                $scope.phaseStart($scope.vm.CityPickData2);
            }
        }
        
    }

    $scope.initSelect();
    $scope.phaseStart=function(datas){
        getConditionTarget.getInUseReleasedArticles(datas.areaData[0],datas.areaData[0],'英语一',datas.areaData[1],datas.areaData[2])
        .success(function(res){
            // console.log(res);
            if(res.numberOfElements<=0){
                $ionicPopup.alert({
                    title:'',
                    template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>君，没有找到任何相关信息</span>",
                    buttons:[{
                        text:'朕知道了',
                        type:'button-xdf',
                    }]
                });
            }else{
                var _paraUpperCase=['一','二','三','四','五','六','七']
                var paragraphNum=datas.areaData[2].substr(-1);
                // console.log(paragraphNum);
                var _paragraphNum=_paraUpperCase.indexOf(paragraphNum);
                $scope.para=res.content[0].paragraphs[_paragraphNum];
                paragraphInfo.saveParagraph($scope.para);
                // console.log($scope.para);
                if(angular.isUndefined($scope.para)){
                    $ionicPopup.alert({
                        title:'',
                        template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>君，没有找到您要的段落</span>",
                        buttons:[{
                            text:'朕知道了',
                            type:'button-xdf',
                        }]
                    });
                }
                $scope.startLearningParagraph($scope.para.id)
            }
        });
    }
}]);

myapp.directive('paragraphDirective', ['misc','$compile', function(misc,$compile){
    // Runs during compile
    return {
        restrict: 'A', // E = Element, A = Attribute, C = Class, M = Comment
        link: function($scope, element, attrs) {
            if($scope.para.difficultyDegree.length<10){
                $scope.para.difficultyDegree=misc.giveStar($scope.para.difficultyDegree,{'class':'energized'});
            }
            element.html($scope.para.difficultyDegree);
            $compile(element.contents())($scope);
        }
    };
}]);

myapp.directive('lzOnHold',['$parse',function($parse){
    
    return {
        restrict:'A',
        link:function($scope,element,attrs){
            var timeOutEvent;
            var pandingNotMove=0;
            var oldx,oldy,sumx=0,sumy=0,sumd=0;
            var startTime,endTime;
            var myFun=attrs.lzOnHold;
            // var myAttrs=attrs.lzOnHold.split(';');


            // console.log('myAttrs is ')
            // console.log(myAttrs);
            var clickEvent=function(k){
                var clickHandler = angular.isFunction(k)?k :$parse(k);
                $scope.$apply(function() {
                   clickHandler($scope, {$event: (event)});
                });
                // $scope.startSentenceLearning($scope.para.sentences[k].id);
            }
            var holdEvent=function(k){
                // alert('长按时间'+k);
                var holdHandler = angular.isFunction(k)?k :$parse(k);
                $scope.$apply(function() {
                   holdHandler($scope, {$event: (event)});
                });
                // $scope.giveGeneralMeaning(k);
            }


            element.on('touchstart',function(e){
                // e.preventDefault();
                sumx=sumy=sumd=0;
                oldx=e.changedTouches[0].clientX;
                oldy=e.changedTouches[0].clientY;
                var _t=new Date;
                startTime=_t.valueOf();
                _t=undefined;
            });
            element.on('touchmove',function(e){
                
                var m=Math;
                var nowx=e.changedTouches[0].clientX;
                var nowy=e.changedTouches[0].clientY;

                sumx=m.abs(nowx-oldx);
                sumy=m.abs(nowy-oldy);
                sumd+=sumx+sumy;
                oldx=nowx;oldy=nowy;
                // console.log(sumd);
                m=undefined;
                
            });
            element.on('touchend',function(e){
                var _t=new Date;
                endTime=_t.valueOf();
                var result=endTime-startTime;
                if(sumd<30){
                    pandingNotMove=1;
                }
                if(pandingNotMove==1){
                    // 没有移动的情况下  在判断按的时间是否超过了500MS
                    if(result>500){
                        //这里是长按事件；
                        holdEvent(myFun);
                        e.preventDefault();

                    }else{
                        //这里是点击事件；
                        // clickEvent(myFun);
                    }
                }
                pandingNotMove=0;
                sumx=sumy=sumd=0;
                return false; 
            });
        }
    }
}]);

myapp.controller('paragraph', ['misc','$stateParams','tempSave','questionsResult','shuffle','$rootScope','$ionicPlatform','countTimer','$ionicSlideBoxDelegate','learning','active','paragraphInfo','ajax','userinfo','$scope','sentenceInfo','$state','$ionicPopup','evaluateResult','getTimestamp',
    function(misc,$stateParams,tempSave,questionsResult,shuffle,$rootScope,$ionicPlatform,countTimer,$ionicSlideBoxDelegate,learning,active,paragraphInfo,ajax,userinfo,$scope,sentenceInfo,$state,$ionicPopup,evaluateResult,getTimestamp){
    // var action=active.action;
    // console.log(action);
    $scope.show={};
    $scope.proSentence='';
    var user=userinfo.getUser();
    $scope.baseEva='';
    $scope.paragraphSlideCurrent=tempSave.getData('paragraphSlideCurrent')||0;
    // $scope.sentenceFlag='';
    // console.log(angular.isUndefined(tempSave.getData('sentenceFlag')));
    if(angular.isUndefined(tempSave.getData('sentenceFlag'))){
        $scope.sentenceFlag='notshow';
    }else{
        $scope.sentenceFlag=tempSave.getData('sentenceFlag');
    }
    // console.log('$scope.sentcentFlag');
    // console.log($scope.sentenceFlag);
    paragraphInfo.saveParagraphStatus(1);
    $scope.init=function(callback){
        $scope.optionStatus={};
        $scope.sub=tempSave.getData('sub')||{};
        $scope.para=paragraphInfo.getParagraph();
        // console.log('此时的paragraph Questions');
        // console.log($scope.para.simulatedQuestions);
        angular.forEach($scope.para.simulatedQuestions,function(va,k){
            va.myType='para';
            $scope.para.simulatedQuestions[k].options=shuffle(va.options);
            angular.forEach(va.options,function(sv,sk){
                $scope.optionStatus[sv.id]=false;
            });
        });
        //这里作为了一个对象的引用  会导致出错 所以使用克隆方法
        $scope.baseEva=angular.copy($scope.para.simulatedQuestions);
        // console.log('para active id');
        // console.log($scope.baseEva);
        angular.forEach($scope.para.sentences,function(va,key){
            if(va.simulatedQuestions.length!=0){
                angular.forEach(va.simulatedQuestions,function(sv,sk){
                    sv.myType='sentence';
                    // sv.actionid=active.action.id;
                    $scope.baseEva.push(sv);
                });
                va.myType='sentence';
                // console.log('pro句子');
                $scope.proSentence=va.id;
                // console.log($scope.proSentence);

            }
        });
        // console.log('第二次');
        // console.log($scope.baseEva);
        // 初始化结果报告base
        // 这里的初始化 仅仅在第一次进入段落的时候需要，
        // 当进入了句子，再返回段落的时候就不能再进行初始化了
        var _notBaseInit=tempSave.getData('notBaseInit');
        // console.log('notbaseInit');
        // console.log(_notBaseInit);
        if(_notBaseInit!=true){
            evaluateResult.prepareEva($scope.baseEva,'paraAndSen');
        }
        questionsResult.saveBody($scope.para);
        // console.log($scope.para);
        // $scope.$apply();
        $scope.maxQuestion=$scope.para.simulatedQuestions.length;
        $scope.currentQuestion=0;
        if($scope.currentQuestion!=$scope.maxQuestion){
            $scope.showNext=1;
        }
        // console.log($scope.para); 
        if($scope.para.simulatedQuestions.length){
            $scope.questionStatus=1;   
        }else{
            $scope.questionStatus=0; 
        }
        callback(tempSave.getData('paragraphSlideCurrent'));
    }
    $scope.pendingPage=function(current){
        if(current!=$scope.maxQuestion-1){
            $scope.showNext=1;
            $scope.showResult=0;
        }else if(current==$scope.maxQuestion-1){
            $scope.showNext=0;
            $scope.showResult=1;
        }
    }

    $scope.testDrag=function(e){
        // console.log('on-drag');
        alert('testDrag');
    }

    $scope.init($scope.pendingPage);

    $scope.$on('paragraphChanged',function(event,data){
        // console.log('进入广播 paragraphChanged');
        $scope.init();
        $scope.$apply();
    });

    $scope.toNext=function(){
        $scope.currentQuestion++;
        $scope.pendingPage($scope.currentQuestion);
        $ionicSlideBoxDelegate.next();
        // console.log($scope.question);
    }
    $scope.toPrevious=function(){
        $scope.currentQuestion--;
        $scope.pendingPage($scope.currentQuestion);
        $ionicSlideBoxDelegate.previous();
        // console.log($scope.question);
    }

    $scope.giveGeneralMeaning=function(k){
        $ionicPopup.alert({
            title:'君，中文是酱紫的',
            template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>"+$scope.para.sentences[k].preciseTranslation+"</span>",
            buttons:[{
                text:'朕知道了',
                type:'button-xdf',
            }]
        });
    }

    // console.log(paragraphInfo);
    $scope.startSentenceLearning=function(sid){
        var goStart=true;
        angular.forEach($scope.para.sentences,function(va,key){
            if(va.id==sid){
                // sentenceInfo.saveSentence(va);
                if(va.simulatedQuestions.length==0){
                    goStart=false;
                }
            }
        });
        if(!goStart){
            // console.log('goStart false');
            return false;
        }
        var gps=misc.getGPS();
        learning.startSentenceLearning(sid,gps,user.id)
        .success(function(res){
            tempSave.saveData('sub',$scope.sub);
            tempSave.saveData('notBaseInit',true);
            // console.log('开始句子学习');
            // console.log(res);
            sentenceInfo.saveSentenceAction(res);
            angular.forEach($scope.para.sentences,function(va,key){
                if(va.id==sid){
                    sentenceInfo.saveSentence(va);
                }
            });
            tempSave.saveData('paragraphSlideCurrent',$ionicSlideBoxDelegate.currentIndex())
            $state.go('sentence',{'from':'paragraph'});
        });
    }

    $scope.goProSentence=function(){
        if($scope.proSentence!=''){
            $scope.startSentenceLearning($scope.proSentence);
        }
    }
    
    $scope.slideChanged = function(index) {
        $scope.currentQuestion = index;
        $scope.pendingPage($scope.currentQuestion);
    };
    //排除段落模拟题选项
    $scope.giveup=function(opid){
        if(!$scope.optionStatus[opid]){
            learning.addParagraphLearningSimulatedSingleAnswerQuestionOptionOperation(active.action.id,$scope.para.simulatedQuestions[$scope.currentQuestion].id,opid,'','')
            $scope.optionStatus[opid]=true;
        }else{
            learning.addParagraphLearningSimulatedSingleAnswerQuestionOptionOperation(active.action.id,$scope.para.simulatedQuestions[$scope.currentQuestion].id,opid,'取消排除','')
            $scope.optionStatus[opid]=false;
        }
    }

    $scope.raiseErrorMessage=function(){
        $scope.errorMessage={};
        // console.log('提交一个错误，raiseErrorMessage');
        var dat={};
        dat.year=$scope.errorMessage.year=$scope.para.year;
        dat.part=$scope.errorMessage.part=$scope.para.part;
        dat.subject=$scope.errorMessage.subject=$scope.para.subject;
        dat.descr=misc.getNowTime();

        var t=$ionicPopup.show({
            title:'我要提交一个建议',
            templateUrl:'templates/raiseErrorMessage.html',
            scope:$scope,
            buttons:[{
                text:'确认',
                type:'button,button-xdf',
                onTap:function(e){
                    return $scope.errorMessage.errorDescr;
                }
            },{
                text:'取消',
                type:'button,button-xdf',
                
            }]
        });
        t.then(function(r){
            if(!angular.isUndefined(r)){
                dat.errorDescr=r;
                misc.raiseErrorMessage(dat);
            }
        })

    }
    //返回摇一摇界面
    $scope.returnParagraphWave=function(){
        // countTimer.stopTimer();
        // waveandwave.startWatch('paragraph');

        $ionicPopup.confirm({
            'title':'自学君提示您',
            'template':"<span class='zhf_bianda'>您确定要退出吗？这将会丢失当前的学习记录</span>",
            'cancelText':'取消',
            'cancelType':'button-light',
            'okText':'确定',
            'okType':'button-xdf',
        }).then(function(r){
            if(r){
                tempSave.clearDataAll();
                var timer=countTimer.getTimer();
                learning.updateParagraphLearningDuration(timer,active.action.id);
                var _d=$stateParams.from;
                if(!angular.isUndefined(_d)&&_d!=''){
                    $state.go(_d);
                }else{
                    $state.go('paragraphWave',{},{'location':'relpace','reload':true});
                }
            }
        });


    }

    $scope.goShowResult=function(){
        tempSave.clearDataAll();
        var timer=getTimestamp();
        learning.updateParagraphLearningDuration(timer,active.action.id);
        $state.go('showResult',{'from':'paragraph'});
    };

    $scope.directSubmit=function(e){
        e.stopPropagation();
        $scope.toSubmit();
    }


    $scope.toSubmit=function(directiveValue){
        // console.log(qid);
        if(angular.isUndefined(directiveValue)){
            $scope.sub[qid]=directiveValue;
        }
        // console.log($scope.sub);
        var thisQuestion=$scope.para.simulatedQuestions[$scope.currentQuestion];
        thisQuestion.myType='para';
        var qid=$scope.para.simulatedQuestions[$scope.currentQuestion].id;
        var op=$scope.para.simulatedQuestions[$scope.currentQuestion].options[$scope.sub[qid]];
        // console.log(op);
        // var isCorrect=false;
        // angular.forEach(thisQuestion.options,function(va,k){
        //     if(va.id==op){
        //         isCorrect=va.isCorrect;
        //     }
        // });
        if(angular.isUndefined(op)){
            $ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda'>您还没有选择答案</span>",
                buttons:[{
                    text:'朕知道了',
                    type:'button-xdf',
                }]
            });
            return false;
        }

        learning.addParagraphLearningSimulatedSingleAnswerQuestionAnswer(qid,op.id,op.isCorrect,active.action.id)
        .success(function(res){
            // console.log('更新模拟题所选答案');
            // console.log(res);
            var alertPopup=$ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda '>提交答案成功</span>",
                buttons:[{
                    text:'朕知道了',
                    type:'button-xdf',
                }]
            });
            alertPopup.then(function(res) {

                var _obj={};
                _obj.myType=thisQuestion.myType;
                _obj.id=qid;
                _obj.opid=op.id;
                _obj.actionid=active.action.id;
                _obj.isCorrect=op.isCorrect;
                _obj.questionType=thisQuestion.questionType;
                evaluateResult.saveResult(_obj);
                _obj=undefined;

                if($scope.showNext){
                    $scope.toNext();
                }
                //可能会直接显示报告;
                // if($scope.showResult){
                //      $scope.goShowResult();
                // }
            });
            
        });
    }

    $scope.recordAnalysis=function(opid){
        if($scope.show[opid]==true){
            // console.log($scope.show[opid]);
            // console.log(opid);
            learning.addParagraphLearningSimulatedSingleAnswerQuestionOptionOperation(active.action.id,$scope.para.simulatedQuestions[$scope.currentQuestion].id,opid,'查看解析','')
        }
    }
    // $rootScope.returnUpper=$scope.returnParagraphWave;
    $rootScope.returnParagraphWave=$scope.returnParagraphWave;

    // $ionicPlatform.onHardwareBackButton(function(e){
    //     $scope.returnParagraphWave();
    //     e.preventDefault();
    // });
}]);

myapp.controller('sentence', ['tempSave','$rootScope','$ionicPlatform','countTimer','active','learning','$ionicSlideBoxDelegate','sentenceInfo','$stateParams','$state','$scope','$location','shuffle','getTimestamp','$ionicPopup','evaluateResult',
    function(tempSave,$rootScope,$ionicPlatform,countTimer,active,learning,$ionicSlideBoxDelegate,sentenceInfo,$stateParams,$state,$scope,$location,shuffle,getTimestamp,$ionicPopup,evaluateResult){
    // console.log('进入句子的控制器');
    $scope.init=function(){
        // console.log(active);
        // console.log('调用句子init')
        $scope.sub={};
        $scope.optionStatus={};
        $scope.show={}
        $scope.currentQuestion=0;
        // console.log($stateParams);        
        $scope.sentence=sentenceInfo.getSentence();
        // console.log($scope.sentence)
        angular.forEach($scope.sentence.simulatedQuestions,function(va,k){
            $scope.sentence.simulatedQuestions[k].options=shuffle(va.options);
            // va.actionid=active.action.content.id;
            angular.forEach(va.options,function(sv,sk){
                $scope.optionStatus[sv.id]=false;
                $scope.show[sv.id]=false;
            });
        });
        // console.log($scope.para);
        $scope.maxQuestion=$scope.sentence.simulatedQuestions.length;
        if($scope.currentQuestion!=$scope.maxQuestion){
            $scope.showNext=1;
        }
        if($scope.currentQuestion==0){
            $scope.showPrevious=0;
        }
        if($scope.sentence.simulatedQuestions.length){
            $scope.questionStatus=1;   
        }else{
            $scope.questionStatus=0; 
        }
    }
    $scope.init();
    $scope.recordAnalysis=function(opid){
        if($scope.show[opid]==true){
            var qid=$scope.sentence.simulatedQuestions[$scope.currentQuestion].id;            
            learning.addSentenceLearningSimulatedSingleAnswerQuestionOptionOperation(active.action.content.id,qid,opid,'查看解析','');
        }
    }
    $scope.returnToFrom=function(){
        // var timer=countTimer.getTimer();
        var timer=getTimestamp();
        // console.log('timer段落计时器');
        console.log(timer);
        learning.updateSentenceLearningDuration(timer,active.action.content.id);
        $state.go($stateParams.from);
    }

    $rootScope.returnToFrom=$scope.returnToFrom;
    // $ionicPlatform.onHardwareBackButton(function(e){
    //     $scope.returnToUpper();
    //     e.preventDefault();
    // });
    $scope.$on('sentenceChanged',function(event,data){
        // console.log('收到sentenceChanged的广播');
        // console.log(data)
        // $scope.init();
    });
    // $rootScope.$on('sentenceChanged',function(e,d){
    //     console.log('rootScope中获取的广播');
    //     // console.log(d);
    //     $scope.init();
    // });
    $scope.pendingPage=function(current){
        if(current!=$scope.maxQuestion-1){
            $scope.showNext=1;
            $scope.showResult=0;
        }else if(current==$scope.maxQuestion-1){
            $scope.showNext=0;
            $scope.showResult=1;
        }
    }

    $scope.slideChanged = function(index) {
        $scope.currentQuestion = index;
        $scope.pendingPage($scope.currentQuestion);
    };
    //排除段落模拟题选项
    $scope.giveup=function(opid){
        var qid=$scope.sentence.simulatedQuestions[$scope.currentQuestion].id;
        // console.log(active.action.content.id);
        // console.log(qid);
        // console.log(opid);
        if(!$scope.optionStatus[opid]){
            learning.addSentenceLearningSimulatedSingleAnswerQuestionOptionOperation(active.action.content.id,qid,opid,'','')
            $scope.optionStatus[opid]=true;
        }else{
            learning.addSentenceLearningSimulatedSingleAnswerQuestionOptionOperation(active.action.content.id,qid,opid,'取消排除','')
            $scope.optionStatus[opid]=false;
        }
    };
    $scope.giveGeneralMeaning=function(){
        $ionicPopup.alert({
            title:'君，中文是酱紫的',
            template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>"+$scope.sentence.preciseTranslation+"</span>",
            buttons:[{
                text:'朕知道了',
                type:'button-xdf',
            }]
        });
    }

    $scope.directSubmit=function(e){
        e.stopPropagation();
        $scope.toSubmit();
    }

    $scope.toSubmit=function(){
        // console.log(qid);
        // console.log($scope.sub);
        var thisQuestion=$scope.sentence.simulatedQuestions[$scope.currentQuestion];
        thisQuestion.myType='sentence';
        var qid=$scope.sentence.simulatedQuestions[$scope.currentQuestion].id;
        var op=$scope.sentence.simulatedQuestions[$scope.currentQuestion].options[$scope.sub[qid]];
        // console.log(op);

        if(angular.isUndefined(op)){
            $ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda'>您还没有选择答案</span>",
                buttons:[{
                    text:'朕知道了',
                    type:'button-xdf',
                }]
            });
            return false;

        } 

        learning.addSentenceLearningSimulatedSingleAnswerQuestionAnswer(qid,op.id,op.isCorrect,active.action.content.id)
        .success(function(res){
            // console.log('更新句子单选题答案');
            // console.log(res);
            var alertPopup=$ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda'>提交答案成功</span>",
                buttons:[{
                    text:'朕知道了',
                    type:'button-xdf',
                }]
            });
            alertPopup.then(function(res) {
                var _obj={};
                _obj.myType=thisQuestion.myType||'word';
                _obj.id=qid;
                _obj.opid=op.id;
                _obj.actionid=active.action.content.id;
                _obj.isCorrect=op.isCorrect;
                _obj.questionType=thisQuestion.questionType;
                evaluateResult.saveResult(_obj);
                _obj=undefined;

                if($scope.showNext){
                    $scope.toNext();
                }
                //可能会直接显示报告;
                // if($scope.showResult){
                //     $scope.goShowResult();
                // }
                //检测几个句子是不是都已经提交答案；
                var _tempEva=evaluateResult.getResultForErrorQuestions();
                // console.log('tempEva');
                // console.log(_tempEva);
                var _tf=true;
                angular.forEach(_tempEva,function(tv,tk){
                    if(tv.myType=='sentence'){
                        if(tv.opid==''){
                            tempSave.saveData('sentenceFlag','notshow');
                            _tf=false;
                        }
                        // console.log('此时TF');
                        // console.log(_tf);
                    }
                });
                if(_tf==true){
                    // console.log('sentcentFlag = show');
                    // tempSave.saveData('sentenceFlag','show');
                }

                
            });
            
        });
    };
    $scope.toNext=function(){
        $scope.currentQuestion++;
        $scope.pendingPage($scope.currentQuestion);
        $ionicSlideBoxDelegate.next();
        // console.log($scope.question);
    }
    $scope.toPrevious=function(){
        $scope.currentQuestion--;
        $scope.pendingPage($scope.currentQuestion);
        $ionicSlideBoxDelegate.previous();
        // console.log($scope.question);
    }
}]);
//阅读题界面控制器  要继续细化


//完善个人资料
myapp.controller('editProfile',['$rootScope','$ionicPlatform','$scope','userinfo','ajax','$state',
    function($rootScope,$ionicPlatform,$scope,userinfo,ajax,$state){
    // console.log('修改我的个人资料')
    $scope.profile={};
    $scope.user=userinfo.getUser();
    // console.log($scope.user);

    $scope.changeMyProfile=function(){
        var url="updateProfile.na";
        var senddata={
            'action.id':$scope.user.id,
            'name':$scope.user.profile.name,
            'sex':$scope.user.profile.sex,
            'qqInfo':$scope.user.qqInfo,
            'weChatInfo':$scope.user.weChatInfo
        }
        ajax.tp(url,senddata,'kv')
        .success(function(res){
            // console.log(res);
        })
    }

    $scope.returnLogin=function(){
        $state.go('login');
    }

    $rootScope.returnLogin=$scope.returnLogin;

}]);


myapp.directive('domFinish',['$ionicPlatform','$timeout','paragraphInfo','$rootScope',
    function($ionicPlatform,$timeout,paragraphInfo,$rootScope){
   return {
       strict:'A',
       link:function(scope,element,attrs){
            // scope.addEventListener
            // $timeout(waveandwave.startWatch(),100);
            // waveandwave.startWatch('word');
            // console.log(res);
            // $rootScope.$on('paragraphChanged',function(event,data){
            //     scope.para=paragraphInfo.getParagraph();
            // });
       }
   }
}]);

//背单词页面
myapp.controller('word', ['misc','getConditionTarget','$ionicPopup','selectDataForPicker','$rootScope','$ionicPlatform','$scope','$http','ajax','$state','wordSearch','getWords','$window','wordsStatus','learning','userinfo', 
    function(misc,getConditionTarget,$ionicPopup,selectDataForPicker,$rootScope,$ionicPlatform,$scope,$http,ajax,$state,wordSearch,getWords,$window,wordsStatus,learning,userinfo){
    var user=userinfo.getUser();
    wordsStatus.saveStatus(0);
    $scope.condition={
        'year':'',
        'degreeOfDifficulty':'',
        'partOfSpeech':''
    };

    $scope.returnStudyOption=function(){
        $state.go('studyOption.studyOptionContent');
    }
    $scope.goPattrnSetting=function(){
        $state.go('studyOption.pattrnSetting');
    }
    $scope.goContact=function(){
        $state.go('studyOption.contactUs');
    }
    $scope.goLogin=function(){
        $state.go('studyOption.login');
    }
   
    $rootScope.returnStudyOption=$scope.returnStudyOption;

    $scope.conditionSearch=function(){
        var url="listRandomWords.na";
        ajax.tp(url,{'num':15},'kv')
        .success(function(res){
            // console.log(res);
            getWords.saveWords(res);
            $state.go('wordPage');
        });
    }

    $scope.goSentence=function(){
        $state.go('sentence',{from:'word'});
    }
   
    $scope.wave=function(){
        //摇一摇，并创建一条单词学习记录
        var url="startWordLearning.na";
        //坐标应该从这里传输
        var gps=misc.getGPS();
        var _dat={'executor.id':user.id,'record.location':gps};
        ajax.tp(url,_dat,'kv')
        .success(function(res){
            getWords.saveWords(res);
            $state.go('wordPage');
        })
    }
    var pickData=selectDataForPicker.word();
    $scope.initSelect=function(){
        var vm=$scope.vm={};
        //旋转完毕 显示areaData;
        vm.CityPickData = {
            areaData: ['请选择城市'],
            title: '请选择学习的年份',
            defaultAreaData: ['2015','阅读一',''], //这里可以从其他地方传值过来作为默认值
            areaService:pickData,
            buttonText:"确定",
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                // console.log('点击完成');
                // console.log(vm.CityPickData.areaData);
                $scope.wordStart();
            }
        }
    }
    $scope.initSelect();
    $scope.wordStart=function(){
        getConditionTarget.listRandomWords($scope.vm.CityPickData.areaData[0],$scope.vm.CityPickData.areaData[0],'英语一',$scope.vm.CityPickData.areaData[1])
        .success(function(res){
            // console.log(res);
            if(res.length<=0){
                $ionicPopup.alert({
                    title:'',
                    template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>君，没有找到任何相关信息</span>",
                    buttons:[{
                        text:'朕知道了',
                        type:'button-xdf',
                    }]
                });
            }else{
                getWords.saveWords(res);
                $state.go('wordPage',{'from':'word'});
            }
        });
    }
}]);

//单词显示页面
myapp.directive('wordPageDirective', ['misc','$compile', function(misc,$compile){
    // Runs during compile
    return {
        restrict: 'A', // E = Element, A = Attribute, C = Class, M = Comment
        link: function($scope, element, attrs) {
            k=attrs.wordPageDirective;
            element.html($scope.words[k].degreeOfDifficulty);
            $compile(element.contents())($scope);
        }
    };
}]);

myapp.controller('wordPage', ['setting','$stateParams','habbit','misc','$ionicSlideBoxDelegate','$rootScope','$ionicPlatform','ajax','getWords','$scope','$interval','$timeout','userinfo','$window','wordsStatus','$state','active','learning','$ionicPopup',
    function(setting,$stateParams,habbit,misc,$ionicSlideBoxDelegate,$rootScope,$ionicPlatform,ajax,getWords,$scope,$interval,$timeout,userinfo,$window,wordsStatus,$state,active,learning,$ionicPopup){
    
    $scope.wordsGroups=[];
    $scope.wlAction={};
    $scope.process={};
    $scope.showGoGroup=false;
    if($stateParams.from!=''){
        $scope.showGoGroup=true;
    }
    var user=userinfo.getUser();
    var wordStatus=active.wordStatus;
    var tempWordGroupNum=active.tempWordGroupNum;
    $scope.process.length=active.words.length;

    // console.log(active.words);
    $scope.goToWordsGroups=function(to){
        if(to=='pre'){
            // console.log('pre');
            if($scope.nowWordsGroups==0){
                return false;
            }
            $scope.nowWordsGroups=parseInt($scope.nowWordsGroups-1);
        }else if(to=='next'){
            // console.log('next');
            if($scope.nowWordsGroups==tempWordGroupNum-1){
                return false;
            }
            $scope.nowWordsGroups=parseInt($scope.nowWordsGroups+1);
        }
        $scope.words=$scope.wordsGroups[$scope.nowWordsGroups];
        angular.forEach($scope.words,function(va,k){
            if(va.degreeOfDifficulty.length<10){
                va.degreeOfDifficulty=misc.giveStar(va.degreeOfDifficulty,{'class':'energized'});
            }
        });
        $ionicSlideBoxDelegate.update();
        $ionicSlideBoxDelegate.slide(0);
        $scope.stopCountTimer(0);
        $scope.stopCountTimer($scope.lastPage);
        $scope.pendingPage(0);
        $scope.startLearningThisWordsGroup($scope.words);
    }

    var makeWordGroup=function(){
        //初始化词组并分类
        for(var m=0;m<tempWordGroupNum;m++){
            $scope.wordsGroups[m]=[];
        }
        var i=0;
        var j=0;
        angular.forEach(active.words,function(va,k){
            if(i<tempWordGroupNum){
                if(j<15){
                    // $scope.wordsGroups[i].push(va);
                }else{
                    j=0;
                    i++;
                }
                $scope.wordsGroups[i].push(va);
                j++;
            }
        })
        $scope.lastPage=0;
    }
    makeWordGroup();
    $scope.nowWordsGroups=0;
    $scope.words=$scope.wordsGroups[$scope.nowWordsGroups];

    $scope.startLearningThisWordsGroup=function(group){
        // console.log("运行 startLearningThisWordsGroup");
        $scope.wlAction.len=group.length;
        // $scope.process.length=$scope.wlAction.len;
        $scope.wlAction.timer=[];
        $scope.wlAction.countTimer='';
        $scope.wlAction.actionarr=[];
        var _atarr=[];
        for(var i=0;i<$scope.wlAction.len;i++){
            $scope.wlAction.timer[i]=0;
        }        
        $timeout(function(){
            
            for (var i=0 ;i<$scope.wlAction.len;i++) {
                var _action=angular.fromJson($window.localStorage['nowWordActionId.'+$scope.nowWordsGroups+'.'+i]);
                // console.log('此时的i：'+i+',此时的action：'+_action.id);
                if(!angular.isUndefined(_action)){
                    _atarr.push(_action);
                }
            }
            $scope.wlAction.actionarr=_atarr;
        },1000);
    }
    $scope.startLearningThisWordsGroup($scope.words);
    // console.log('此时的actionarr');
    // console.log($scope.wlAction.actionarr);
    //转换难度为图标星星

    angular.forEach($scope.words,function(va,k){
        if(va.degreeOfDifficulty.length<10){
            va.degreeOfDifficulty=misc.giveStar(va.degreeOfDifficulty,{'class':'energized'});
        }
    });
    //这里要使用getLocation的服务获取坐标信息。
    // console.log($scope.words);

    $scope.returnWord=function(){
        // waveandwave.startWatch('word');
        $ionicPopup.confirm({
            'title':'自学君提示您',
            'template':"<span class='zhf_bianda'>您确定要退出吗？这将会丢失当前的学习记录</span>",
            'cancelText':'取消',
            'cancelType':'button-light',
            'okText':'确定',
            'okType':'button-xdf',
        }).then(function(r){
            if(r){
                //这里的r就是true
                var _d=$stateParams.from;
                if(_d!=''&&!angular.isUndefined(_d)){
                    $state.go(_d);
                }else{
                    $state.go('word');
                }
            }
        });
    }

    $scope.tanchu=function(k){
        /* 暂时关闭
        $scope.showWordGroupObj=$scope.words[$ionicSlideBoxDelegate.currentIndex()].readings[k];
        console.log($scope.showWordGroupObj);
        $ionicPopup.alert({
            title:null,
            templateUrl:'templates/alertWordGroup.html',
            scope:$scope,
            buttons:[{
                text:'朕知道了',
                type:'button-xdf',
            }]
        });
        */
    }

    $scope.raiseErrorMessage=function(){
        $scope.currentIndex=$ionicSlideBoxDelegate.currentIndex();
        $scope.errorMessage={};
        // console.log('提交一个错误，raiseErrorMessage');
        var dat={};
        dat.year=$scope.errorMessage.year=$scope.words[$scope.currentIndex].readings[0].year;
        dat.part=$scope.errorMessage.part=$scope.words[$scope.currentIndex].readings[0].part;
        dat.subject=$scope.errorMessage.subject=$scope.words[$scope.currentIndex].readings[0].subject;
        dat.target=$scope.errorMessage.target=$scope.words[$scope.currentIndex].spell;
        dat.descr=misc.getNowTime();
        var t=$ionicPopup.show({
            title:'我要提交一个建议',
            templateUrl:'templates/raiseErrorMessage.html',
            scope:$scope,
            buttons:[{
                text:'确认',
                type:'button,button-xdf',
                onTap:function(e){
                    return $scope.errorMessage.errorDescr;
                }
            },{
                text:'取消',
                type:'button,button-xdf',
                
            }]
        });
        t.then(function(r){
            if(!angular.isUndefined(r)){
                dat.errorDescr=r;
                misc.raiseErrorMessage(dat);
            }
        })
    }

    $rootScope.returnWord=$scope.returnWord;
    
    $scope.startCountTime=function(index){
        $scope.wlAction.countTimer=$interval(function(){
            $scope.wlAction.timer[index]=parseInt($scope.wlAction.timer[index])+1;
        },1000);
    }
    $scope.startCountTime(0);
    $scope.showPage={
        'pre':false,
        'next':false,
    }
    $scope.stopCountTimer=function(index){
        $interval.cancel($scope.wlAction.countTimer);
    }

    $scope.pendingPage=function(index){
        if($scope.nowWordsGroups==0){
            $scope.showPage.pre=false;
        }else{
            $scope.showPage.pre=true;
        }
        if(($scope.nowWordsGroups!=(tempWordGroupNum-1))&&(tempWordGroupNum-1!=0)){
            $scope.showPage.next=true;
        }else{
            $scope.showPage.next=false;
        }
    }
    $scope.pendingPage(0);
    //发送请求表示该单词已经学习过
    $scope.slideHasChanged=function(index){
        // console.log('slideHasChanged');
        $scope.currentIndex=index;
        $scope.process.currentIndex=index+1;
        $scope.pendingPage(index);
        var _p=1+index+$scope.nowWordsGroups*setting.wordNum;
        var _tp=active.words.length;
        // console.log(_p+' = '+_tp);
        if(_p==_tp){
            $scope.showAddons=1;
        }else{
            $scope.showAddons=0;
        }
        $timeout(function(){
            $scope.stopCountTimer($scope.lastPage);
            $scope.startCountTime(index);
            console.log($scope.wlAction.timer);
            // console.log($scope.wlAction.actionarr);
            learning.updateWordLearningDuration($scope.wlAction.actionarr[$scope.lastPage].id,$scope.wlAction.timer[$scope.lastPage]);
            //处理完逻辑后 将现在的页面序号赋值给上一页
            $scope.lastPage=index;
        },500);
    }

    $scope.goFlashWord=function(){
        $interval.cancel($scope.wlAction.countTimer);
        if($stateParams.from!=''){
            $state.go('flashWord',{'from':'word'});
        }else{
            $state.go('flashWord');
        }
    }
    $scope.goTestWord=function(){
        $interval.cancel($scope.wlAction.countTimer);
        $interval.cancel($scope.wlAction.countTimer);
        if($stateParams.from!=''){
            $state.go('testWord',{'from':'word'});
        }else{
            $state.go('testWord');
        }
    }


}]);
//做单词的题目
myapp.controller('testWord', ['$stateParams','setting','questionsResult','$ionicPopup','shuffle','$rootScope','$ionicPlatform','ajax','getWords','$scope','$ionicSlideBoxDelegate','userinfo','$window','wordsStatus','$state','evaluateResult','learning',
    function($stateParams,setting,questionsResult,$ionicPopup,shuffle,$rootScope,$ionicPlatform,ajax,getWords,$scope,$ionicSlideBoxDelegate,userinfo,$window,wordsStatus,$state,evaluateResult,learning){
    var user=userinfo.getUser();
    $scope.allQuestions=[];
    $scope.process={};
    $scope.showGoGroup=false;
    if($stateParams.from!=''){
        $scope.showGoGroup=true;
    }
    wordsStatus.saveStatus(1);
    $scope.optionStatus={};
    $scope.wordsGroups=[];
    $scope.wlAction={};
    var _qv=[];
    // $scope.questions=[];
    $scope.questionsGroup=[]
    $scope.rememberWord=[];
    var _tempWords=getWords.conditional();
    var tempWordGroupNum=Math.ceil(_tempWords.length/15);
    // questionsResult.saveBody($scope.words);
    questionsResult.saveBody(_tempWords);

    $scope.goToWordsGroups=function(to){
        if(to=='pre'){
            // console.log('pre');
            if($scope.nowWordsGroups==0){
                return false;
            }
            $scope.nowWordsGroups=parseInt($scope.nowWordsGroups-1);
        }else if(to=='next'){
            // console.log('next');
            if($scope.nowWordsGroups==tempWordGroupNum-1){
                return false;
            }
            $scope.nowWordsGroups=parseInt($scope.nowWordsGroups+1);
        }
        $scope.words=$scope.wordsGroups[$scope.nowWordsGroups];
        $scope.questions=$scope.questionsGroup[$scope.nowWordsGroups];
        $ionicSlideBoxDelegate.update();
        $ionicSlideBoxDelegate.slide(0);
        $scope.startLearningThisWordsGroup($scope.words);
        $scope.pendingPage(0);
    }

    // $scope.pendingPage=function(index){

    // }

    var makeWordGroup=function(){ 
        //2个公共参数    tempWordGroupNum 还有一个参数就是传进来的单词组 
        // 内部执行了 $scope.lastPage=1
        // 返回 $scope.wordGroups的数组
        // 决定是否需要  删除现有的wordAction[m][i]
        for(var m=0;m<tempWordGroupNum;m++){
            $scope.wordsGroups[m]=[];
            $scope.questionsGroup[m]=[];
        }
        var i=0;
        var j=0;
        angular.forEach(_tempWords,function(va,k){
            if(i<tempWordGroupNum){
                if(j<15){
                    $scope.wordsGroups[i].push(va);
                    j++;
                }else{
                    j=0;
                    i++;
                }
            }
        })
        $scope.lastPage=0;
    }
    makeWordGroup();
    $scope.nowWordsGroups=0;
    $scope.words=$scope.wordsGroups[$scope.nowWordsGroups];
    $scope.process.length=_tempWords.length;

    $scope.startLearningThisWordsGroup=function(group){
        $scope.wlAction.len=group.length;
        // $scope.process.length=$scope.wlAction.len;
        $scope.wlAction.actionarr=[];
        var _actionarr=[];
        var _atarr=[];
        //下面这一步感觉没有必要，因为没有什么动作执行需要ACTIONID 而且在下面初始化单词question的时候已经将对应的ID赋进去了
        for (var i=0 ;i<$scope.wlAction.len;i++) {
            var _action=angular.fromJson($window.localStorage['nowWordActionId.'+$scope.nowWordsGroups+'.'+i]);
            if(!angular.isUndefined(_action)){
                _atarr.push(_action);
            }
        }
        $scope.wlAction.actionarr=_atarr;
    }
    $scope.startLearningThisWordsGroup($scope.words);

    // var index=$ionicSlideBoxDelegate.currentIndex();
    // var num=_qv[index];
    var i=0,j=0;
    angular.forEach(_tempWords,function(va,k){
        if(i<tempWordGroupNum){
            if(j<15){
                action=angular.fromJson($window.localStorage['nowWordActionId.'+i+'.'+j]);
            }else{
                j=0;
                i++;
            }
        }
        // console.log('标记');
        // console.log(action);
        if(va.questions.length>0){
            va.questions[0].wordSpell=_tempWords[k].spell;
            va.questions[0].options=shuffle(va.questions[0].options);
            va.questions[0].actionid=action.id; //考虑将actionid移到点击的地方再生成
            angular.forEach(va.questions[0].options,function(sv,sk){
                $scope.optionStatus[sv.id]=false;
            })
            $scope.allQuestions.push(va.questions);
            $scope.questionsGroup[i][j]=va.questions;
            var _l=$scope.allQuestions.length;
            _l=_l-1;
            _qv[_l]=k;
        }
        j++;
    })
    //初始化题目为第0组
    $scope.questions=$scope.questionsGroup[0];
    // console.log('测试新功能');
    console.log($scope.questionsGroup);
    console.log($scope.questions);
    evaluateResult.prepareEva($scope.allQuestions,'word');

    $scope.currentQuestion=0;
    $scope.maxQuestion=$scope.questions.length;
    $scope.showPage={
        'pre':false,
        'next':false
    }

    $scope.pendingPage=function(current){
        //判定是否出现‘显示答案’的按钮
        // console.log(current)
        var _np=$scope.nowWordsGroups*setting.wordNum+current;
        var _p=_tempWords.length-1;
        // console.log(_p);
        // if(current!=$scope.maxQuestion-1){
        if(_np!=_p){
            $scope.showNext=1;
            $scope.showResult=0;
        }else if(_np==_p){
            $scope.showNext=0;
            $scope.showResult=1;
        }
        if($scope.nowWordsGroups==0){
            $scope.showPage.pre=false;
        }else{
            $scope.showPage.pre=true;
        }
        if(($scope.nowWordsGroups!=(tempWordGroupNum-1))&&((tempWordGroupNum-1)!=0)){
            $scope.showPage.next=true;
        }else{
            $scope.showPage.next=false;
        }
        // console.log($scope.showPage);
        // console.log($scope.showGoGroup);
    }
    $scope.pendingPage($scope.currentQuestion);
    $scope.goShowResult=function(){
        $state.go('showResult',{'from':'word'},{'reload':true});
    }
    // $scope.slideHasChanged=function(index){
        
    // }
    $scope.returnWordPage=function(){
        //返回单词学习界面，这里可以加一个弹出框
        if($stateParams.from!=''){
            $state.go('wordPage',{'from':'word'});
        }else{
            $state.go('wordPage');
        }
    }

    $rootScope.returnWordPage=$scope.returnWordPage;

     //做单词题答案
    $scope.addWordLearningSingleAnswerQuestionResult=function(questionId,optionid,isCorrect,actionId,userId){
        var url="addWordLearningSingleAnswerQuestionResult.na";
        var _dat={'question.id':questionId,'userAnswer.id':optionid,'isCorrect':isCorrect,'result.action.id':actionId,'executor.id':userId};
        // console.log('做题答案');
        // console.log(_dat);
        ajax.tp(url,_dat,'kv')
        .success(function(res){
            // console.log('测试做单词题目');
            // console.log(res);
            var alertPopup=$ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda'>提交答案成功</span>",
                buttons:[{
                    text:'朕知道了',
                    type:'button-xdf',
                }]
            });
            alertPopup.then(function(res) {
                var index=$ionicSlideBoxDelegate.currentIndex();
                var thisQuestion=$scope.questions[index][0];
                var _obj={};
                _obj.myType=thisQuestion.myType||'word';
                _obj.id=questionId;
                _obj.isCorrect=isCorrect;
                _obj.opid=optionid;
                _obj.actionid=actionId;
                _obj.questionType=thisQuestion.questionType;
                evaluateResult.saveResult(_obj);
                _obj=undefined;

                if($scope.showNext){
                    $scope.toNext();
                }
            });
        });
    }

    $scope.directSubmit=function(e){
        e.stopPropagation();
        $scope.toSubmit();
    }

    $scope.toSubmit=function(){
        //确认题目的答案
        var index=$ionicSlideBoxDelegate.currentIndex();
        var isCorrect=false;
        var questionId='';
        var thisQuestion=$scope.questions[index][0];
        var actionId='';
        questionId=thisQuestion.id;
        var optionid=$scope.rememberWord[questionId];

        // console.log('thisQuestion is :');
        // console.log(thisQuestion);

        if(angular.isUndefined(optionid)){
            $ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda'>您还没有选择答案</span>",
                buttons:[{
                    text:'朕知道了',
                    type:'button-xdf',
                }]
            });
            return false;

        }        
        angular.forEach(thisQuestion.options,function(va,k){
            if(va.id==optionid){
                isCorrect=va.isCorrect;
            }
        });
        // var num=_qv[index];
        // action=angular.fromJson($window.localStorage['nowWordActionId.'+$scope.nowWordsGroups+'.'+num]);
        actionId=thisQuestion.actionid;
        // console.log(isCorrect);
        // console.log($scope.rememberWord[aimId]);
        $scope.addWordLearningSingleAnswerQuestionResult(questionId,optionid,isCorrect,actionId,user.id);
    }
    $scope.slideChanged = function(index) {
        $scope.currentQuestion = index;
        $scope.process.currentIndex = index + 1
        $scope.pendingPage($scope.currentQuestion);
    };
    $scope.toNext=function(){
        $scope.currentQuestion++;
        $scope.pendingPage($scope.currentQuestion);
        $ionicSlideBoxDelegate.next();
    }
    $scope.toPrevious=function(){
        $scope.currentQuestion--;
        $scope.pendingPage($scope.currentQuestion);
        $ionicSlideBoxDelegate.previous();
    }

    $scope.giveup=function(opid){
        var index=$ionicSlideBoxDelegate.currentIndex();
        var thisQuestion=$scope.questions[index][0];
        var qid=thisQuestion.id;
        var num=_qv[index];

        action=angular.fromJson($window.localStorage['nowWordActionId.'+tempWordGroupNum+'.'+num]);
        // console.log(active.action.content.id);
        // console.log(qid);
        // console.log(opid);
        if(!$scope.optionStatus[opid]){
            learning.addWordLearningQuestionOptionOperation(action.id,qid,opid,'','')
            $scope.optionStatus[opid]=true;
        }else{
            learning.addWordLearningQuestionOptionOperation(action.id,qid,opid,'取消排除','')
            $scope.optionStatus[opid]=false;
        }
    }
}]);
myapp.directive('flashWordDirective', ['$compile', function($compile){
    // Runs during compile
    return {
        restrict: 'A', // E = Element, A = Attribute, C = Class, M = Comment
        link: function($scope, element, attrs) {
            var k=attrs.flashWordDirective;
            element.html($scope.words[k].degreeOfDifficulty);
            $compile(element.contents())($scope);
        }
    };
}]);
myapp.controller('flashWord', ['$stateParams','setting','$ionicPopup','$rootScope','$ionicPlatform','ajax','getWords','$scope','wordsStatus','$state','$ionicSlideBoxDelegate',
    function($stateParams,setting,$ionicPopup,$rootScope,$ionicPlatform,ajax,getWords,$scope,wordsStatus,$state,$ionicSlideBoxDelegate){
    var flashInterval='';
    $scope.wordsGroups=[];
    $scope.showGoGroup=false;
    if($stateParams.from!=''){
        $scope.showGoGroup=true;
    }
    wordsStatus.saveStatus(1);
    var _tempWords=getWords.conditional();
    var tempWordGroupNum=Math.ceil(_tempWords.length/setting.wordNum);
    $scope.goToWordsGroups=function(to){
        // console.log($scope.nowWordsGroups)
        if(to=='pre'){
            // console.log('pre');
            if($scope.nowWordsGroups==0){
                return false;
            }
            $scope.nowWordsGroups=parseInt($scope.nowWordsGroups-1);
        }else if(to=='next'){
            // console.log('next');
            if($scope.nowWordsGroups==tempWordGroupNum-1){
                return false;
            }
            $scope.nowWordsGroups=parseInt($scope.nowWordsGroups+1);
        }
        $scope.words=$scope.wordsGroups[$scope.nowWordsGroups];
        $ionicSlideBoxDelegate.update();
        $ionicSlideBoxDelegate.slide(0);
        $scope.pendingPage(0);
    }
    var makeWordGroup=function(){
        //初始化词组并分类
        for(var m=0;m<tempWordGroupNum;m++){
            $scope.wordsGroups[m]=[];
        }
        var i=0;
        var j=0;
        angular.forEach(_tempWords,function(va,k){
            if(i<tempWordGroupNum){
                if(j<15){
                }else{
                    j=0;
                    i++;
                }
            }
            $scope.wordsGroups[i].push(va);
            j++;
        })
        $scope.lastPage=0;
        // console.log($scope.wordsGroups);
        // console.log($scope.lastPage);
    }
    makeWordGroup();
    $scope.nowWordsGroups=0;
    $scope.words=$scope.wordsGroups[$scope.nowWordsGroups];

    $rootScope.flashSpeed=1000;
    $scope.flashing=1;
    $scope.process={};
    $scope.process.length=_tempWords.length;
    $scope.setTime={};
    // $scope.words=getWords.conditional();
    // $scope.process.length=$scope.words.length;
    
    $scope.decide=function(t){

        if(angular.isUndefined($scope.setTime.setting)){
            $scope.setTime.setting=3;
        }
        if($scope.setTime.setting!=t){
            $scope.setTime.setting=t;
        }
        // console.log($scope.setTime.setting);
        $scope.setTime.setting*=1000;
        // $ionicSlideBoxDelegate.update();
        flashInterval=setInterval(function(){
            $ionicSlideBoxDelegate.next();
        },$scope.setTime.setting);
        flashWordTimingShow.close();
    }


    var flashWordTimingShow=$ionicPopup.show({
        title:'请选择回闪间隔时间',
        templateUrl:'templates/flashWordTime.html',
        scope:$scope,
    })

    $scope.returnWordPage=function(){
        clearInterval(flashInterval);
        if($stateParams!=''){
            $state.go('wordPage',{'from':'word'});
        }else{
            $state.go('wordPage');
        }
    }
    $scope.showPage={'pre':false,'next':false};
    $scope.goTestWord=function(){
        clearInterval(flashInterval);
        if($stateParams.from!=''){
            $state.go('testWord',{'from':'word'});
        }else{
            $state.go('testWord');
        }
    }
    $scope.pendingPage=function(index){
        // console.log($scope.nowWordsGroups);
        // console.log(tempWordGroupNum-1);
        if($scope.nowWordsGroups==0){
            $scope.showPage.pre=false;
        }else{
            $scope.showPage.pre=true;
        }
        if(($scope.nowWordsGroups!=(tempWordGroupNum-1))&&((tempWordGroupNum-1)!=0)){
            $scope.showPage.next=true;
        }else{
            $scope.showPage.next=false;
        }
    }
    $scope.pendingPage(0);
    $scope.slideHasChanged=function(index){
        $scope.flashing=1;
        $scope.process.currentIndex=index+1;
        $scope.pendingPage(index);
    //     var _p=1+index+$scope.nowWordsGroups*setting.wordNum;
    //     var _tp=active.words.length-1;
    //     console.log(_p+' = '+_tp);
    //     if(_p==_tp){
    //         $scope.showAddons=1;
    //     }else{
    //         $scope.showAddons=0;
    //     }
    }

    $scope.minusFlashSpeed=function(){
        $rootScope.flashSpeed-=300;
        // console.log($rootScope.flashSpeed);
        $ionicSlideBoxDelegate.update();

    }
    $scope.addFlashSpeed=function(){
        $rootScope.flashSpeed+=300;
        $ionicSlideBoxDelegate.update();
        // console.log($rootScope.flashSpeed);
    }

    $rootScope.returnWordPage=$scope.returnWordPage;

    $scope.stopFlash=function(){
        $ionicSlideBoxDelegate.stop();
        clearInterval(flashInterval);
        $scope.flashing=0;
    }
    $scope.startFlash=function(){
        flashInterval=setInterval(function(){
            $ionicSlideBoxDelegate.next();
        },$scope.setTime.setting);
        $scope.flashing=1;
    }

}]);


myapp.directive('radialIndicator', ['radialIndicatorInstance',function (radialIndicatorInstance) {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            var element = element,
                id = attrs.radialIndicatorId,
                options = scope.$eval(attrs.radialIndicator),
                model = attrs.radialIndicatorModel;
                // console.log(attrs);
            var indInstance = radialIndicator(element, options);

            //store indicator instance on radialIndicatorConfig so can get through dependency injection
            if (id) radialIndicatorInstance[id] = indInstance;

            //watch for modal change
            scope.$watch(model, function (newValue) {
                indInstance.value(newValue);
            });

            //delete the idnicator instance when scope dies
            scope.$on('$destroy', function () {
                if (id) delete radialIndicatorInstance[id];
            });

        }
    }
}]);
myapp.controller('showResult', ['$ionicPopup','userinfo','tempSave','questionsResult','active','evaluateResult','$rootScope','$state','$scope','$stateParams',
    function($ionicPopup,userinfo,tempSave,questionsResult,active,evaluateResult,$rootScope,$state,$scope,$stateParams){
    var user=userinfo.getUser();
    var from=$stateParams.from;
    // console.log(from);
    $scope.returnStudyOption=function(){
        evaluateResult.clearResult();
        $state.go('studyOption.studyOptionContent');
    }

    $scope.goContact=function(){
        evaluateResult.clearResult();
        $state.go('studyOption.contactUs');
    }
    $scope.goPattrnSetting=function(){
        evaluateResult.clearResult();
        $state.go('studyOption.pattrnSetting');
    }
    $scope.goLogin=function(){
        evaluateResult.clearResult();
        $state.go('studyOption.login');
    }

    $scope.goCompareResult=function(){
        $state.go('compareResult',{'from':from});
    }
    var sendMailShow;
    $scope.closeSendMailShow=function(){
        sendMailShow.close();
    }
    $scope.sendThisResult=function(){
        if(user.accountName==null){
            $ionicPopup.alert({
                title:'自学君提示您',
                template:"<span class='zhf_bianda'>您还没有注册成为正式账号，请尽快注册以便使用全部功能。</span>",
                buttons:[{
                    text:'朕知道了',
                    type:'button,button-xdf'
                },{
                    text:'去注册',
                    type:'button,button-xdf',
                    onTap:function(){
                        $state.go('loginRegist');
                        evaluateResult.clearResult();
                    }
                }]
            })
        }else{
            // console.log(user);
            if(user.profile.mails!=null&&user.profile.mails.indexOf(',')){
                $scope.emails=user.profile.mails.split(',');
            }
            sendMailShow=$ionicPopup.show({
                title:'自学君提示您',
                templateUrl:"templates/sendEmailPopup.html",
                scope:$scope,
                buttons:[{
                    text:'放弃',
                    type:'button,button-xdf'
                }]
            })
        }
    }

    $scope.sendToThisEmail=function(email){
        var title=user.accountName+'的学习邮件通知';
         $scope.closeSendMailShow();
        evaluateResult.getEvaluateResultEamil($scope.result,email);
        // misc.sendMail(email,title,content);
    }

    // $scope.result=evaluateResult.getResult();
    $scope.result=active.getResult;
    tempSave.saveData('thisResult',$scope.result);
    var _days=['天','一','二','三','四','五','六'];
    var _m=new Date();
    $scope.nowTime=_m.getFullYear()+'-'+(_m.getMonth()+1)+'-'+_m.getDate()+' '+_m.getHours()+':'+_m.getMinutes()+':'+_m.getSeconds()+' 星期'+_days[_m.getDay()];
    if($scope.result.paraAccuracy>=0){
        $scope.paragraphShow=1;
    }
    if($scope.result.wordAccuracy>=0){
        $scope.wordShow=1;
    }

    // console.log($scope.result);
    $rootScope.returnUpper=$scope.returnStudyOption;
    $scope.goErrorQuestion=function(){
        $state.go('errorQuestion',{'from':from});
    }   
}]);

myapp.directive('showResultDirective', ['$compile', function($compile){
    return {
        // name: '',
        // priority: 1,
        // terminal: true,
        // scope: {}, // {} = isolate, true = child, false/undefined = no change
        // controller: function($scope, $element, $attrs, $transclude) {},
        // require: 'ngModel', // Array = multiple requires, ? = optional, ^ = check parent elements
        restrict: 'A', // E = Element, A = Attribute, C = Class, M = Comment
        // template: '',
        // templateUrl: '',
        // replace: true,
        // transclude: true,
        // compile: function(tElement, tAttrs, function transclude(function(scope, cloneLinkingFn){ return function linking(scope, elm, attrs){}})),
        link: function($scope, element, attrs, controller) {
            var _target=attrs.showResultDirective;
            if(angular.isUndefined(_target)||(_target=='')){
                _target=$scope.result.wlScore;
            }
            element.html(_target);
            $compile(element.contents())($scope);
        }
    };
}]);


myapp.controller('errorQuestion', ['$ionicSlideBoxDelegate','$ionicSideMenuDelegate','$ionicPopup','$state','questionsResult','evaluateResult','$stateParams','$scope','$rootScope', 
    function($ionicSlideBoxDelegate,$ionicSideMenuDelegate,$ionicPopup,$state,questionsResult,evaluateResult,$stateParams,$scope,$rootScope){
    
    var from=$stateParams.from;
    $scope.resultStatus=from;
    // console.log($scope.resultStatus);
    $scope.words=[];
    $scope.showGoGroup=false;
    $scope.sub={};
    $scope.tsub={};
    $scope.result={};
    $scope.allWords=[];
    $scope.body=questionsResult.getBody();
    var tempWordGroupNum=Math.ceil($scope.body.length/15);
    // console.log($scope.body.length+' | '+tempWordGroupNum);
    for(var i=0;i<tempWordGroupNum;i++){
        $scope.allWords[i]=[];
    }
    $scope.nowWordsGroups=0;
    var select=evaluateResult.getResultForErrorQuestions();
    angular.forEach(select,function(va,k){
        $scope.tsub[va.id]=va.opid;
    });
    $scope.showPage={
        'pre':false,
        'next':false
    }
    $scope.pendingPage=function(current){
        //判定是否出现‘显示答案’的按钮
        if($scope.nowWordsGroups==0){
            $scope.showPage.pre=false;
        }else{
            $scope.showPage.pre=true;
        }
        if(($scope.nowWordsGroups!=(tempWordGroupNum-1))&&((tempWordGroupNum-1)!=0)){
            $scope.showPage.next=true;
        }else{
            $scope.showPage.next=false;
        }
    }
    $scope.pendingPage(0);

    $scope.goToWordsGroups=function(to){
        if(to=='pre'){
            // console.log('pre');
            if($scope.nowWordsGroups==0){
                return false;
            }
            $scope.nowWordsGroups=parseInt($scope.nowWordsGroups-1);
        }else if(to=='next'){
            // console.log('next');
            if($scope.nowWordsGroups==tempWordGroupNum-1){
                return false;
            }
            $scope.nowWordsGroups=parseInt($scope.nowWordsGroups+1);
        }
        $scope.words=$scope.allWords[$scope.nowWordsGroups];
        $ionicSlideBoxDelegate.update();
        $ionicSlideBoxDelegate.slide(0);
        $scope.pendingPage(0);
        // $scope.startLearningThisWordsGroup($scope.words);
    }


    // console.log($scope.tsub);
    var loop='';
    if(from=='eva'){
        loop=$scope.body;
    }else if(from=='article'){
        loop=$scope.body.pastQuestions;
    }else if(from=='word'){
        $scope.showGoGroup=true;
        loop=$scope.body;
    }else if(from=='paragraph'){
        $scope.body.questions='';
        $scope.body.questions=$scope.body.simulatedQuestions;
        angular.forEach($scope.body.sentences,function(va,k){
            if(va.simulatedQuestions.length){
                angular.forEach(va.simulatedQuestions,function(sv,sk){
                    sv.mainContent=va.text;
                    $scope.body.questions.push(sv);
                })
            }
        });
        loop=$scope.body.questions;
    }

    var x=0;var y=0;
    angular.forEach(loop,function(va,k){
        if(from=='word'){
            if(va.questions.length>0){
                // console.log('执行push');
                // console.log(va);
                angular.forEach(va.questions[0].options,function(sv,sk){
                    if($scope.tsub[va.questions[0].id]==sv.id){
                        $scope.sub[va.questions[0].id]=sk; //还原用户所选的选项
                    }
                });
                if(x<15){
                    $scope.allWords[y].push(va.questions[0]);
                    x++;
                }else{
                    x=0;
                    y++;
                    $scope.allWords[y].push(va.questions[0]);
                }
            }
        }else{
            angular.forEach(va.options,function(sv,sk){
                if($scope.tsub[va.id]==sv.id){
                    $scope.sub[va.id]=sk;
                }
            });
        }
    });
    // console.log($scope.allWords)
    $scope.words=$scope.allWords[$scope.nowWordsGroups];
    $scope.slideChanged=function(index){
    }

    $scope.giveGeneralMeaning=function(k,sk){
        if(angular.isUndefined(sk)){
            $scope.giveGeneralMeaningByParagraph(k);                        
        }else{
            $scope.giveGeneralMeaningByArticle(k,sk);
        }

    }

    $scope.giveGeneralMeaningByParagraph=function(k){
        $ionicPopup.alert({
            title:'君，中文是酱紫的',
            template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>"+$scope.body.sentences[k].preciseTranslation+"</span>",
            buttons:[{
                text:'朕知道了',
                type:'button-xdf',
            }]
        });
    }

    $scope.giveGeneralMeaningByArticle=function(k,sk){
        $ionicPopup.alert({
            title:'君，中文是酱紫的',
            template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>"+$scope.body.paragraphs[k].sentences[sk].preciseTranslation+"</span>",
            buttons:[{
                text:'朕知道了',
                type:'button-xdf',
            }]
        });
    }


    // console.log('errorQuestion');
    // console.log($scope.body);
    // console.log(select);
    // console.log($scope.sub);
    $scope.toggleRightMenu=function(){
        $ionicSideMenuDelegate.toggleRight();
    }

    $scope.doItAgain=function(){
        switch(from){
            case 'article':
                $state.go('articleList');
                break;
            case 'paragraph':
                $state.go('paragraphWave');
                break;
            case 'word':
                $state.go('word');
                break;
        }
    }

    $scope.returnStudyOption=function(){
        evaluateResult.clearResult();
        $state.go('studyOption.studyOptionContent');
    }
}])

myapp.controller('others', ['$rootScope','$state','$scope' ,function($rootScope,$state,$scope){
    $scope.returnStudyOption=function(){
        $state.go('studyOption.studyOptionContent');
    }
    $rootScope.returnStudyOption=$scope.returnStudyOption;
}])
myapp.controller('pattrnSetting', ['misc','paragraphInfo','$ionicSlideBoxDelegate','userinfo','learning','getWords','getConditionTarget','$ionicPopup','$compile','habbit','selectDataForPicker','$rootScope','$scope','$state', 
    function(misc,paragraphInfo,$ionicSlideBoxDelegate,userinfo,learning,getWords,getConditionTarget,$ionicPopup,$compile,habbit,selectDataForPicker,$rootScope,$scope,$state){
    var user=userinfo.getUser();
    $scope.para={};
    $scope.overstyle={};
    $scope.overstyle[0]=true;
    $scope.gomouyiye=function(x){
        // $scope.overstyle={};
        // $scope.overstyle[x]=true;
        $scope.slideChanged($scope.overstyle,x);
        // console.log(x);
        $ionicSlideBoxDelegate.slide(x);
    }

    $scope.slideChanged=function(overstyle,x){
        // overstyle={};
        angular.forEach(overstyle,function(va,k){
            overstyle[k]=false;
        });
        var a=x||$ionicSlideBoxDelegate.currentIndex();
        // console.log(a);
        // console.log(overstyle);
        overstyle[a]=true;
    }

    var pickData=selectDataForPicker.word();
    $scope.startLearningParagraph=function(pid){
        var gps=misc.getGPS();
        learning.startParagraphLearning(pid,gps,user.id,'paragraph','studyOption.pattrnSetting')
        $scope.para='';
    }

    $scope.wordStart=function(datas){
        getConditionTarget.listRandomWords(datas.areaData[0],datas.areaData[0],'英语一',datas.areaData[1])
        .success(function(res){
            // console.log(res);
            if(res.length<=0){
                $ionicPopup.alert({
                    title:'',
                    template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>君，没有找到任何相关信息</span>",
                    buttons:[{
                        text:'朕知道了',
                        type:'button-xdf',
                    }]
                });
            }else{
                getWords.saveWords(res);
                $state.go('wordPage',{'from':'studyOption.pattrnSetting'});
            }
        });
    }
    $scope.phaseStart=function(datas){
        getConditionTarget.getInUseReleasedArticles(datas.areaData[0],datas.areaData[0],'英语一',datas.areaData[1],datas.areaData[2])
        .success(function(res){
            // console.log(res);
            if(res.numberOfElements<=0){
                $ionicPopup.alert({
                    title:'',
                    template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>君，没有找到任何相关信息</span>",
                    buttons:[{
                        text:'朕知道了',
                        type:'button-xdf',
                    }]
                });
            }else{
                var _paraUpperCase=['一','二','三','四','五','六','七']
                var paragraphNum=datas.areaData[2].substr(-1);
                // console.log(paragraphNum);
                var _paragraphNum=_paraUpperCase.indexOf(paragraphNum);
                $scope.para=res.content[0].paragraphs[_paragraphNum];
                paragraphInfo.saveParagraph($scope.para);
                // console.log($scope.para);
                if(angular.isUndefined($scope.para)){
                    $ionicPopup.alert({
                        title:'',
                        template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>君，没有找到您要的段落</span>",
                        buttons:[{
                            text:'朕知道了',
                            type:'button-xdf',
                        }]
                    });
                }
                $scope.startLearningParagraph($scope.para.id)
            }
        });
    }

    $scope.articleStart=function(datas){
        getConditionTarget.getInUseReleasedArticles(datas.areaData[0],datas.areaData[0],'英语一',datas.areaData[1])
        .success(function(res){
            // console.log(res);
            if(res.numberOfElements<=0){
                $ionicPopup.alert({
                    title:'',
                    template:"<span style=' color:#585858; line-height:24px; padding-top:-10px;' class='zhf_bianda'>君，没有找到任何相关信息</span>",
                    buttons:[{
                        text:'朕知道了',
                        type:'button-xdf',
                    }]
                });
            }else{
                // console.log(res);
                $state.go('article',{'aid':res.content[0].id,'from':'studyOption.pattrnSetting'});
            }
        });
    }

    $scope.initSelect=function(){

        $scope.vm={};
        //旋转完毕 显示areaData;
        $scope.vm.CityPickData1_1 = {
            areaData: [],
            title: '2006年—2008年  真题词汇',
            defaultAreaData: [],
            areaService:selectDataForPicker.word(2006,2008),
            cssClass:'zhf-35h',
            buttonText:"确定",
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.wordStart($scope.vm.CityPickData1_1);
            }
        }

        $scope.vm.CityPickData1_2 = {
            areaData: [],
            title: '2006年—2008年  阅读精练',
            defaultAreaData: [],
            areaService:selectDataForPicker.paragraph(2006,2008),
            buttonText:"确定",
            cssClass:'zhf-35h',
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.phaseStart($scope.vm.CityPickData1_2);
            }
        }
        $scope.vm.CityPickData1_3 = {
            areaData: [],
            title: '2006年—2008年  真题模考',
            defaultAreaData: [],
            areaService:selectDataForPicker.word(2006,2008),
            cssClass:'zhf-35h',
            buttonText:"确定",
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.articleStart($scope.vm.CityPickData1_3);
            }
        }
        $scope.vm.CityPickData2_1 = {
            areaData: [],
            title: '2009年-2011年  真题词汇',
            defaultAreaData: [],
            areaService:selectDataForPicker.word(2009,2011),
            cssClass:'zhf-35h',
            buttonText:"确定",
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.wordStart($scope.vm.CityPickData2_1);
            }
        }
        $scope.vm.CityPickData2_2 = {
            areaData: [],
            title: '2009年-2011年  阅读精练',
            defaultAreaData: [],
            areaService:selectDataForPicker.paragraph(2009,2011),
            buttonText:"确定",
            cssClass:'zhf-35h',
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.phaseStart($scope.vm.CityPickData2_2);
            }
        }
        $scope.vm.CityPickData2_3 = {
            areaData: [],
            title: '2009年-2011年  真题模考',
            defaultAreaData: [],
            areaService:selectDataForPicker.word(2009,2011),
            cssClass:'zhf-35h',
            buttonText:"确定",
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.articleStart($scope.vm.CityPickData2_3);
            }
        }
        $scope.vm.CityPickData3_1 = {
            areaData: [],
            title: '2012年—2015年  真题词汇',
            defaultAreaData: [],
            areaService:selectDataForPicker.word(2012,2015),
            cssClass:'zhf-35h',
            buttonText:"确定",
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.wordStart($scope.vm.CityPickData3_1);
            }
        }
        $scope.vm.CityPickData3_2 = {
            areaData: [],
            title: '2012年—2015年  阅读精练',
            defaultAreaData: [],
            areaService:selectDataForPicker.paragraph(2012,2015),
            buttonText:"确定",
            cssClass:'zhf-35h',
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.phaseStart($scope.vm.CityPickData3_2);
            }
        }
        $scope.vm.CityPickData3_3 = {
            areaData: [],
            title: '2012年—2015年  真题模考',
            defaultAreaData: [],
            areaService:selectDataForPicker.word(2012,2015),
            cssClass:'zhf-35h',
            buttonText:"确定",
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.articleStart($scope.vm.CityPickData3_3);
            }
        }
        $scope.vm.CityPickData4_1 = {
            areaData: [],
            title: '2016年  真题词汇',
            defaultAreaData: [],
            areaService:selectDataForPicker.word(2016,2016),
            cssClass:'zhf-35h',
            buttonText:"确定",
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.wordStart($scope.vm.CityPickData4_1);
            }
        }
        $scope.vm.CityPickData4_2 = {
            areaData: [],
            title: '2016年  阅读精练',
            defaultAreaData: [],
            areaService:selectDataForPicker.paragraph(2016,2016),
            buttonText:"确定",
            cssClass:'zhf-35h',
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.phaseStart($scope.vm.CityPickData4_2);
            }
        }
        $scope.vm.CityPickData4_3 = {
            areaData: [],
            title: '2016年  真题模考',
            defaultAreaData: [],
            areaService:selectDataForPicker.word(2016,2016),
            cssClass:'zhf-35h',
            buttonText:"确定",
            hardwareBackButtonClose: false,
            buttonClicked:function(){
                $scope.articleStart($scope.vm.CityPickData4_3);
            }
        }
    }
    $scope.initSelect();

    $rootScope.returnStudyOption=$scope.returnStudyOption;
}])

myapp.controller('showHistory', ['getWords','proActions','paragraphInfo','$state','$scope','$rootScope','getTargetRestart','wordsStatus',
    function(getWords,proActions,paragraphInfo,$state,$scope,$rootScope,getTargetRestart,wordsStatus){
    $scope.listEnd=false;
    $scope.actionGroupList=[];
    $scope.showNoHistory=false;
    $scope.$on('scroll.infiniteScrollComplete',function(event,data){
        // console.log(data);
        // if(data==1){
        //     data=true;
        // }
        $scope.listEnd=data;

        // console.log('debug');
        //     return false;
        if($scope.actionGroupList.length<=0){
            $scope.showNoHistory=true;
        }else{
            $scope.showNoHistory=false;
        }
    });

    $scope.returnStudyOption=function(){
        $state.go('studyOption.studyOptionContent');
    }
    $rootScope.returnStudyOption=$scope.returnStudyOption;
    $scope.pages=0;
    // proActions.findSpecifiedActionGroupInPage($scope.pages)
    // .success(function(res){
    //     console.log(res);
    //     var resdata=res.content;
    //     $scope.actionGroupList=resdata.content;
    //     $scope.pages=resdata.number+1;
    //     $scope.$broadcast('scroll.infiniteScrollComplete',resdata.last);
    // });
    $scope.loadMore=function(){
        if($scope.listEnd==true){
            return false;
        }
        proActions.findSpecifiedActionGroupInPage($scope.pages)
        .success(function(res){
            // console.log('发送请求返回成功');
            // console.log(res);
            if(res.success){
                var resdata=res.content;
                angular.forEach(resdata.content,function(va,k){

                    $scope.actionGroupList.push(va);
                })


                $scope.pages=resdata.number+1;
                $scope.$broadcast('scroll.infiniteScrollComplete',resdata.last);
            }
        })
    }

    $scope.restart=function(param){
        // console.log(param);
        var ids,type;
        if(param.plActions.length>0){
            type='paragraph';
            ids=param.plActions[0].id;
        }else if(param.wlActions.length>0){
            type="word";
            ids=[];
            angular.forEach(param.wlActions,function(va,k){
                ids.push(va.target);
            });
            wordsStatus.saveStatus(0);
            // console.log(ids);
            getWords.saveWords(ids);
        }else if(param.alActions.length>0){
            type='article';
            ids=param.alActions[0].id;
        }

        // return ;
        // console.log(type);
        // console.log(ids);
        switch(type){
            case 'article':
                getTargetRestart.findTargetArticle(ids)
                .success(function(res){
                    // console.log(res);
                    if(res.success==true){
                        $state.go('article',{'aid':res.content.id});
                    }  
                });
                break;
            case 'paragraph':
                getTargetRestart.findTargetParagraph(ids)
                .success(function(res){
                    // console.log(res);
                    if(res.success==true){
                        paragraphInfo.saveParagraph(res.content);
                        paragraphInfo.saveParagraphStatus(0);
                        $state.go('paragraph',{'pid':res.content.id});
                    }  
                });
                break;
            case 'word':
                // getTargetRestart.findTargetWord(ids)
                // .success(function(res))
                if(ids.length>15){
                    $state.go('wordPage',{'from':'word'});
                }else{
                    $state.go('wordPage');
                }
                break;
            default:
                alert('不在指定范围内。');
        }
    }
}]);

myapp.directive('easyToClick', [function(){
    // Runs during compile
    return {
        // name: '',
        // priority: 1,
        // terminal: true,
        // scope: {}, // {} = isolate, true = child, false/undefined = no change
        // controller: function($scope, $element, $attrs, $transclude) {},
        // require: 'ngModel', // Array = multiple requires, ? = optional, ^ = check parent elements
        restrict: 'A', // E = Element, A = Attribute, C = Class, M = Comment
        // template: '',
        // templateUrl: '',
        // replace: true,
        // transclude: true,
        // compile: function(tElement, tAttrs, function transclude(function(scope, cloneLinkingFn){ return function linking(scope, elm, attrs){}})),
        link: function(scope, element, attrs, controller) {
            element.on('click',function(){
                // console.log(element);
                // element[0].children[0].checked=true;
                // element[0].children[0].select();
                var _clickValue=attrs.easyToClick;
                var _opvalue=attrs.opValue;
                var _qtype=attrs.qtype;
                // console.log(attrs);
                // console.log(_clickValue);
                if(_qtype=='word'){
                    scope.rememberWord[_clickValue]=_opvalue;
                }else{
                    scope.sub[_clickValue]=_opvalue;
                }
                scope.toSubmit();


            });
        }
    };
}]);

myapp.directive('jdtProcess', ['setting',function(setting){
    // Runs during compile
    return {
        // name: '',
        // priority: 1,
        // terminal: true,
        // scope: {}, // {} = isolate, true = child, false/undefined = no change
        // controller: function($scope, $element, $attrs, $transclude) {},
        // require: 'ngModel', // Array = multiple requires, ? = optional, ^ = check parent elements
        restrict: 'A', // E = Element, A = Attribute, C = Class, M = Comment
        // template: '',
        // templateUrl: '',
        // replace: true,
        // transclude: true,
        // compile: function(tElement, tAttrs, function transclude(function(scope, cloneLinkingFn){ return function linking(scope, elm, attrs){}})),
        link: function($scope, iElm, iAttrs, controller) {
            $scope.process.currentIndex=$scope.process.currentIndex||1;
            $scope.$watch('process.currentIndex',function(){
                var _ratio;
                // console.log($scope.process.length);
                // console.log($scope.process.currentIndex);
                // console.log('$scope.nowWordsGroups');
                // console.log($scope.nowWordsGroups);
                if(!angular.isUndefined($scope.nowWordsGroups)){
                    if($scope.nowWordsGroups==0){
                        _ratio=($scope.nowWordsGroups*setting.wordNum+$scope.process.currentIndex)/($scope.process.length);
                    }else{
                        _ratio=($scope.nowWordsGroups*setting.wordNum+$scope.process.currentIndex)/($scope.process.length);
                    }
                }else{
                    // console.log('else');
                    _ratio=($scope.process.currentIndex+1)/($scope.process.length-1);
                }
                // console.log(_ratio);
                iElm[0].style.width=(_ratio*100)+'%';

                // console.log('进度条指令');
                // console.log($scope.process.currentIndex);
                // console.log($scope.process.length);

            });
            // console.log(iElm);
            // console.log(iAttrs);
        }
    };
}]);

myapp.controller('statistics', ['$state','highCharts','proActions','$scope','$rootScope', 
    function($state,highCharts,proActions,$scope,$rootScope){
    var dat=[];
    proActions.findLastSpecifiedActionGroup('paragraph',6)
    .success(function(res){
        var pdat=[];
        if(res.success==true){
            angular.forEach(res.content,function(va,k){
                pdat.unshift(parseInt(va.paraAccuracy));
            });
        }
        $scope.chartConfig.series[1]={
            name: '阅读学习',
            data:pdat,
            yAxis: 0,
            color: '#ee260b'
        };
    });
    proActions.findLastSpecifiedActionGroup('word',6)
    .success(function(res){
        var wdat=[];
        if(res.success==true){
            angular.forEach(res.content,function(va,k){
                wdat.unshift(parseInt(va.wordAccuracy));
            });
        }
        $scope.chartConfig.series[0]={
            name: '单词学习',
            data:wdat,
            yAxis: 0,
            color: '#24a7cb'
        };        
    });
    proActions.findLastSpecifiedActionGroup('article',6)
    .success(function(res){
        var adat=[];
        if(res.success==true){
            angular.forEach(res.content,function(va,k){
                adat.unshift(parseInt(va.artAccuracy));
            });
        }
        $scope.chartConfig.series[2]={
            name: '真题学习',
            data:adat,
            yAxis: 0,
            color: '#93e9d7'
        };
    });
    $scope.chartConfig=highCharts.makeHighCharts(dat);
    // console.log($scope.chartConfig);

    $scope.returnLogin=function(){
        $state.go('studyOption.login');
    }
    $rootScope.returnUpper=$scope.returnLogin;

}])

myapp.controller('compareResult', ['evaluateResult','ajax','active','$rootScope','$scope','$state','tempSave',
    function(evaluateResult,ajax,active,$rootScope,$scope,$state,tempSave){
    
    $scope.getLastResult=function(){
        $scope.thisResult = tempSave.getData('thisResult');
        // console.log(active);

        $scope.lastResult = active.data.content[1];
        if(angular.isUndefined($scope.lastResult)){
            $scope.lastResultShow=true;
        }

        if($scope.thisResult.paraAccuracy>=0){
            $scope.paragraphShow=true;
        }
        if($scope.thisResult.wordAccuracy>=0){
            $scope.wordShow=true;
        }
        // console.log('最近2次的比较结果');
        // console.log($scope.thisResult);
        // console.log($scope.lastResult);
    }
    $scope.getLastResult();
    $scope.returnStudyOption=function(){
        //清除掉结果和考试信息
        evaluateResult.clearResult();
        $state.go('studyOption.studyOptionContent');
    }
    $scope.goPattrnSetting=function(){
        evaluateResult.clearResult();
        $state.go('studyOption.pattrnSetting');
    }
    $scope.goContact=function(){
        evaluateResult.clearResult();
        $state.go('studyOption.contactUs');
    }
    $scope.goLogin=function(){
        evaluateResult.clearResult();
        $state.go('studyOption.login');
    }

    $rootScope.returnUpper=$scope.returnStudyOption;
}])

myapp.controller('ngtestC', ['ajax','getGPS','userinfo','$timeout','$q','$compile','$templateRequest','$templateCache','$ionicSideMenuDelegate','ngtest','$scope','getConditionTarget','misc',
    function(ajax,getGPS,userinfo,$timeout,$q,$compile,$templateRequest,$templateCache,$ionicSideMenuDelegate,ngtest,$scope,getConditionTarget,misc){
    var user=userinfo.getUser();
    $scope.emailvar={'totalAccuracy':60};

    $scope.testGPS=function(){
        var nowGps=misc.getGPS();
        alert(nowGps);
        // var _gps=getGPS.startWatch();
        // console.log(_gps);
        // alert('testGPS');
        // console.log(baidu_location.getCurrentPosition);
        
    }
    // $scope.watchPosition=function(){
    //     var _gps=getGPS.watchPosition();
    // }
    function start(str){
        var defer=$q.defer();
        // console.log('进入Q');
        if(str!=''){
            // $templateRequest(str);
            // console.log(str);
            defer.resolve(str);
            // console.log('str 完毕');
        }else{
            defer.reject('');
        }
        return defer.promise;
    }

    // var promise=start('templates/emailHeader.html')
    // .then(function(str){
    //     return $templateRequest(str).then(function(header){
    //         $scope.emailHeader=header;
    //         return start('templates/email.html');
    //     });
    // }).then(function(str){
    //     $scope.emailBody="<div class='email-warp'>\
    //                 <div class='email-titte'>自学君"+user.accountName+"的学习邮件通知</div>\
    //                 <div class='STYLE1'>"+'随手学阅读'+"</div>\
    //                 <div class='time'><span>时&nbsp;&nbsp;&nbsp;间：2016年7月27日15:05</span></div>\
    //                 <div class='time'><span>2017年英语得分：80分</span></div>\
    //                 <div class='time'><span>阅读理解得分：80%</span></div>\
    //                 </div>";

    //     // return $templateRequest(str).then(function(body){
    //     //     console.log(body);
    //     //     var _t=$compile(body)($scope);
    //     //     console.log(_t);

    //     //     // $templateCache.put('a',_t[0]);
    //     //     // $scope.emailBody=_t[0].outerHTML;
    //     //     // $scope.emailBody=$templateCache.get('a');
    //     //     // $scope.emailBody=_t;
    //     //     return start('templates/emailFooter.html');
    //     // })
    //     return start('templates/emailFooter.html');

    // }).then(function(str){
    //     $templateRequest(str).then(function(footer){
    //         $scope.emailFooter=footer;
    //         $timeout(function(){
    //             $scope.text=$scope.emailHeader+$scope.emailBody+$scope.emailFooter;
    //             // console.log($scope.text);
    //         },1000);
    //     })
    // });

    // $templateRequest('templates/emailHeader.html').then(function(header){
    //     return $q.defer().resolve('ok');
    // }).then(function(){

    // })

    // var _t=$templateRequest('templates/email.html');
    // _t.then(function(res){
    //     $scope.text=$compile(res)($scope);
    //     // $scope.text=res;
    //     console.log($scope.text[7]);

    // })


    $scope.testsubmit=function(){
        var url="addWordLearningSingleAnswerQuestionResult.na";
        var _dat={
            'question.id':426,
            'userAnswer.id':3145,
            'isCorrect':true,
            // 'result.action.id':27545,
            'result.action.id':27457,
            'executor.id':1
        };
        console.log('手动执行addWordLearningSingleAnswerQuestionResult，参数如下');
        console.log(_dat);
        ajax.tp(url,_dat,'kv')
        .success(function(res){
            console.log(res);
        })
    }
    // $scope.testsubmit()

    $scope.test=function(){
        ngtest.start();
    }
    $scope.stest=function(){
        ngtest.stop();
    }
    $scope.sb=function(){
        ngtest.sb();
    }
    $scope.st=function(){
        ngtest.st();
    }

    $scope.toggleRightMenu=function(){
        $ionicSideMenuDelegate.toggleRight();
    }

    $scope.chartConfig = {
        title:{
            text:'您最近6次的学习记录'
        },
        options: {
            chart: {
                type:'spline',
                backgroundColor: 'transparent',
                zoomType: 'xy',
                resetZoomButton: {
                    position: {
                        x: 0,
                        y: -35
                    },
                }
            },
            plotOptions: {
                series: {
                    lineWidth: 1,
                    fillOpacity: 0.5
                },
                column: {
                    stacking: 'normal'
                },
                area: {
                    stacking: 'normal',
                    marker: {
                        enabled: false
                    }
                }

            },
            exporting: false,
            xAxis: [{
                // min:1,
                type: '近六次成绩'
            }],
            yAxis: [
                {
                    min: 0,
                    allowDecimals: false,
                    title: {
                        text: '正确率',
                        style: {
                            color: '#80a3ca'
                        }
                    },
                    labels: {
                        format: '{value}',
                        style: {
                            color: '#80a3ca'
                        }
                    }


                }
            ],
            legend: {
                enabled: true,

            },
            title: {
                text: ' '
            },
            credits: {
                enabled: false
            },

            loading: false,
        },
        series: [
            {
                name: '单词学习',
                data:[35,25,33,25,53,45],
                yAxis: 0,
                color: '#24a7cb'
            },
            {
                name: '阅读学习',
                data:[21,39,53,42,63,12],
                yAxis: 0,
                color: '#ee260b'
            },
            {
                // id: 'iphoneNotificationData',
                name: '真题学习',
                // data: [[1426204800000,12],[1426464000000,6],[1426550400000,10],[1426636800000,3]],
                data:[44,28,43,37,74,45],
                yAxis: 0,
                color: '#93e9d7'
            }
        ],
    }
}])
